"use strict";

exports.__esModule = true;
exports.updateOrderLookupTypeDefinitionRequest = exports.updateEntityTypeRequest = exports.updateCustomerLookupTypeDefinitionRequest = exports.signOutRequest = exports.saveUserCultureRequest = exports.saveUserApplicationRequest = exports.getVersionInfoRequest = exports.getUserScopeTreeRequest = exports.getUserScopeRequest = exports.getUserPermissionsRequest = exports.getUserCultureRequest = exports.getUserApplicationRequest = exports.getTimeZonesRequest = exports.getTaskInfoRequest = exports.getTaskExecutionLogsRequest = exports.getSupportedCulturesRequest = exports.getScopeExtendedConfigurationRequest = exports.getRequesterTasksInfoRequest = exports.getProfileAttributeGroupsRequest = exports.getProductLookupsRequest = exports.getProductDefinitionsRequest = exports.getOrderLookupsRequest = exports.getOrderLookupRequest = exports.getOrderDefinitionRequest = exports.getCustomerLookupsRequest = exports.getCustomerLookupRequest = exports.getCustomerDefinitionsRequest = exports.getCountriesRequest = exports.getAuthorizedApplicationsRequest = exports.getApplicationModules = exports.deleteTaskInfoRequest = exports.createOrderLookupTypeDefinitionRequest = exports.createEntityTypeRequest = exports.createCustomerLookupTypeDefinitionRequest = void 0;
var _buildUrl2 = require("../utils/buildUrl");
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
/* istanbul ignore file */
var createCustomerLookupTypeDefinitionRequest = exports.createCustomerLookupTypeDefinitionRequest = {
  name: "createCustomerLookupTypeDefinitionRequest",
  buildUrl: function buildUrl(lookupName) {
    return (0, _buildUrl2.buildUrl)(["metadata", "lookups", "customer", lookupName]);
  },
  verb: "POST"
};
var createEntityTypeRequest = exports.createEntityTypeRequest = {
  name: "createEntityTypeRequest",
  buildUrl: function buildUrl(entityTypeName) {
    return (0, _buildUrl2.buildUrl)(["metadata", "EntityType", entityTypeName]);
  },
  verb: "POST"
};
var createOrderLookupTypeDefinitionRequest = exports.createOrderLookupTypeDefinitionRequest = {
  name: "createOrderLookupTypeDefinitionRequest",
  buildUrl: function buildUrl(lookupName) {
    return (0, _buildUrl2.buildUrl)(["metadata", "lookups", "order", lookupName]);
  },
  verb: "POST"
};
var deleteTaskInfoRequest = exports.deleteTaskInfoRequest = {
  name: "deleteTaskInfoRequest",
  buildUrl: function buildUrl(taskId, queryParams) {
    return (0, _buildUrl2.buildUrl)(["tasks", taskId], queryParams);
  },
  verb: "DELETE"
};
var getApplicationModules = exports.getApplicationModules = {
  name: "getApplicationModules",
  buildUrl: function buildUrl(applicationName) {
    return (0, _buildUrl2.buildUrl)(["modules", "byApplicationName", applicationName]);
  },
  verb: "GET"
};
var getAuthorizedApplicationsRequest = exports.getAuthorizedApplicationsRequest = {
  name: "getAuthorizedApplicationsRequest",
  buildUrl: function buildUrl() {
    return (0, _buildUrl2.buildUrl)(["my", "applications"]);
  },
  verb: "GET"
};
var getCountriesRequest = exports.getCountriesRequest = {
  name: "getCountriesRequest",
  buildUrl: function buildUrl(queryParams) {
    return (0, _buildUrl2.buildUrl)(["countries"], queryParams);
  },
  verb: "GET"
};
var getCustomerDefinitionsRequest = exports.getCustomerDefinitionsRequest = {
  name: "getCustomerDefinitionsRequest",
  buildUrl: function buildUrl(queryParams) {
    return (0, _buildUrl2.buildUrl)(["metadata", "definitions", "customer"], queryParams);
  },
  verb: "GET"
};
var getCustomerLookupRequest = exports.getCustomerLookupRequest = {
  name: "getCustomerLookupRequest",
  buildUrl: function buildUrl(lookupName) {
    return (0, _buildUrl2.buildUrl)(["metadata", "lookups", "customer", lookupName]);
  },
  verb: "GET"
};
var getCustomerLookupsRequest = exports.getCustomerLookupsRequest = {
  name: "getCustomerLookupsRequest",
  buildUrl: function buildUrl() {
    return (0, _buildUrl2.buildUrl)(["metadata", "lookups", "customer"]);
  },
  verb: "GET"
};
var getOrderDefinitionRequest = exports.getOrderDefinitionRequest = {
  name: "getOrderDefinitionRequest",
  buildUrl: function buildUrl(name, queryParams) {
    return (0, _buildUrl2.buildUrl)(["metadata", "definitions", "order", name], queryParams);
  },
  verb: "GET"
};
var getOrderLookupRequest = exports.getOrderLookupRequest = {
  name: "getOrderLookupRequest",
  buildUrl: function buildUrl(lookupName) {
    return (0, _buildUrl2.buildUrl)(["metadata", "lookups", "order", lookupName]);
  },
  verb: "GET"
};
var getOrderLookupsRequest = exports.getOrderLookupsRequest = {
  name: "getOrderLookupsRequest",
  buildUrl: function buildUrl() {
    return (0, _buildUrl2.buildUrl)(["metadata", "lookups", "order"]);
  },
  verb: "GET"
};
var getProductDefinitionsRequest = exports.getProductDefinitionsRequest = {
  name: "getProductDefinitionsRequest",
  buildUrl: function buildUrl(queryParams) {
    return (0, _buildUrl2.buildUrl)(["products", "definitions"], queryParams);
  },
  verb: "GET"
};
var getProductLookupsRequest = exports.getProductLookupsRequest = {
  name: "getProductLookupsRequest",
  buildUrl: function buildUrl() {
    return (0, _buildUrl2.buildUrl)(["metadata", "lookups", "product"]);
  },
  verb: "GET"
};
var getProfileAttributeGroupsRequest = exports.getProfileAttributeGroupsRequest = {
  name: "getProfileAttributeGroupsRequest",
  buildUrl: function buildUrl() {
    return (0, _buildUrl2.buildUrl)(["metadata", "attributegroups", "profile"]);
  },
  verb: "GET"
};
var getRequesterTasksInfoRequest = exports.getRequesterTasksInfoRequest = {
  name: "getRequesterTasksInfoRequest",
  buildUrl: function buildUrl(queryParams) {
    return (0, _buildUrl2.buildUrl)(["tasks"], queryParams);
  },
  verb: "GET"
};
var getScopeExtendedConfigurationRequest = exports.getScopeExtendedConfigurationRequest = {
  name: "getScopeExtendedConfigurationRequest",
  buildUrl: function buildUrl(scopeId) {
    return (0, _buildUrl2.buildUrl)(["scopes", scopeId, "extendedConfiguration"]);
  },
  verb: "GET"
};
var getSupportedCulturesRequest = exports.getSupportedCulturesRequest = {
  name: "getSupportedCulturesRequest",
  buildUrl: function buildUrl() {
    return (0, _buildUrl2.buildUrl)(["cultures"]);
  },
  verb: "GET"
};
var getTaskExecutionLogsRequest = exports.getTaskExecutionLogsRequest = {
  name: "getTaskExecutionLogsRequest",
  buildUrl: function buildUrl(taskId) {
    return (0, _buildUrl2.buildUrl)(["tasks", taskId, "logs"]);
  },
  verb: "GET"
};
var getTaskInfoRequest = exports.getTaskInfoRequest = {
  name: "getTaskInfoRequest",
  buildUrl: function buildUrl(taskId) {
    return (0, _buildUrl2.buildUrl)(["tasks", taskId]);
  },
  verb: "GET"
};
var getTimeZonesRequest = exports.getTimeZonesRequest = {
  name: "getTimeZonesRequest",
  buildUrl: function buildUrl() {
    return (0, _buildUrl2.buildUrl)(["timezones"]);
  },
  verb: "GET"
};
var getUserApplicationRequest = exports.getUserApplicationRequest = {
  name: "getUserApplicationRequest",
  buildUrl: function buildUrl() {
    return (0, _buildUrl2.buildUrl)(["my", "application"]);
  },
  verb: "GET"
};
var getUserCultureRequest = exports.getUserCultureRequest = {
  name: "getUserCultureRequest",
  buildUrl: function buildUrl() {
    return (0, _buildUrl2.buildUrl)(["my", "culture"]);
  },
  verb: "GET"
};
var getUserPermissionsRequest = exports.getUserPermissionsRequest = {
  name: "getUserPermissionsRequest",
  buildUrl: function buildUrl() {
    return (0, _buildUrl2.buildUrl)(["authentication", "profile"]);
  },
  verb: "GET"
};
var getUserScopeRequest = exports.getUserScopeRequest = {
  name: "getUserScopeRequest",
  buildUrl: function buildUrl(module) {
    return (0, _buildUrl2.buildUrl)(["my", "scope", module]);
  },
  verb: "GET"
};
var getUserScopeTreeRequest = exports.getUserScopeTreeRequest = {
  name: "getUserScopeTreeRequest",
  buildUrl: function buildUrl(module, queryParams) {
    return (0, _buildUrl2.buildUrl)(["my", "scope", module, "tree"], queryParams);
  },
  verb: "GET"
};
var getVersionInfoRequest = exports.getVersionInfoRequest = {
  name: "getVersionInfoRequest",
  buildUrl: function buildUrl(queryParams) {
    return (0, _buildUrl2.buildUrl)(["diagnostic", "versioninfo"], queryParams);
  },
  verb: "GET"
};
var saveUserApplicationRequest = exports.saveUserApplicationRequest = {
  name: "saveUserApplicationRequest",
  buildUrl: function buildUrl(applicationId) {
    return (0, _buildUrl2.buildUrl)(["my", "application", applicationId]);
  },
  verb: "POST"
};
var saveUserCultureRequest = exports.saveUserCultureRequest = {
  name: "saveUserCultureRequest",
  buildUrl: function buildUrl(cultureIso) {
    return (0, _buildUrl2.buildUrl)(["my", "culture", cultureIso]);
  },
  verb: "POST"
};
var signOutRequest = exports.signOutRequest = {
  name: "signOutRequest",
  buildUrl: function buildUrl() {
    return (0, _buildUrl2.buildUrl)(["authentication", "signout"]);
  },
  verb: "POST"
};
var updateCustomerLookupTypeDefinitionRequest = exports.updateCustomerLookupTypeDefinitionRequest = {
  name: "updateCustomerLookupTypeDefinitionRequest",
  buildUrl: function buildUrl(lookupName) {
    return (0, _buildUrl2.buildUrl)(["metadata", "lookups", "customer", lookupName]);
  },
  verb: "PUT"
};
var updateEntityTypeRequest = exports.updateEntityTypeRequest = {
  name: "updateEntityTypeRequest",
  buildUrl: function buildUrl(entityTypeName) {
    return (0, _buildUrl2.buildUrl)(["metadata", "EntityType", entityTypeName]);
  },
  verb: "PUT"
};
var updateOrderLookupTypeDefinitionRequest = exports.updateOrderLookupTypeDefinitionRequest = {
  name: "updateOrderLookupTypeDefinitionRequest",
  buildUrl: function buildUrl(lookupName) {
    return (0, _buildUrl2.buildUrl)(["metadata", "lookups", "order", lookupName]);
  },
  verb: "PUT"
};
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(createCustomerLookupTypeDefinitionRequest, "createCustomerLookupTypeDefinitionRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(createEntityTypeRequest, "createEntityTypeRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(createOrderLookupTypeDefinitionRequest, "createOrderLookupTypeDefinitionRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(deleteTaskInfoRequest, "deleteTaskInfoRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getApplicationModules, "getApplicationModules", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getAuthorizedApplicationsRequest, "getAuthorizedApplicationsRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getCountriesRequest, "getCountriesRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getCustomerDefinitionsRequest, "getCustomerDefinitionsRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getCustomerLookupRequest, "getCustomerLookupRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getCustomerLookupsRequest, "getCustomerLookupsRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getOrderDefinitionRequest, "getOrderDefinitionRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getOrderLookupRequest, "getOrderLookupRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getOrderLookupsRequest, "getOrderLookupsRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getProductDefinitionsRequest, "getProductDefinitionsRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getProductLookupsRequest, "getProductLookupsRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getProfileAttributeGroupsRequest, "getProfileAttributeGroupsRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getRequesterTasksInfoRequest, "getRequesterTasksInfoRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getScopeExtendedConfigurationRequest, "getScopeExtendedConfigurationRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getSupportedCulturesRequest, "getSupportedCulturesRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getTaskExecutionLogsRequest, "getTaskExecutionLogsRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getTaskInfoRequest, "getTaskInfoRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getTimeZonesRequest, "getTimeZonesRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getUserApplicationRequest, "getUserApplicationRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getUserCultureRequest, "getUserCultureRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getUserPermissionsRequest, "getUserPermissionsRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getUserScopeRequest, "getUserScopeRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getUserScopeTreeRequest, "getUserScopeTreeRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getVersionInfoRequest, "getVersionInfoRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(saveUserApplicationRequest, "saveUserApplicationRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(saveUserCultureRequest, "saveUserCultureRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(signOutRequest, "signOutRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(updateCustomerLookupTypeDefinitionRequest, "updateCustomerLookupTypeDefinitionRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(updateEntityTypeRequest, "updateEntityTypeRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(updateOrderLookupTypeDefinitionRequest, "updateOrderLookupTypeDefinitionRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(createCustomerLookupTypeDefinitionRequest, "createCustomerLookupTypeDefinitionRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(createEntityTypeRequest, "createEntityTypeRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(createOrderLookupTypeDefinitionRequest, "createOrderLookupTypeDefinitionRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(deleteTaskInfoRequest, "deleteTaskInfoRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getApplicationModules, "getApplicationModules", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getAuthorizedApplicationsRequest, "getAuthorizedApplicationsRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getCountriesRequest, "getCountriesRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getCustomerDefinitionsRequest, "getCustomerDefinitionsRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getCustomerLookupRequest, "getCustomerLookupRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getCustomerLookupsRequest, "getCustomerLookupsRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getOrderDefinitionRequest, "getOrderDefinitionRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getOrderLookupRequest, "getOrderLookupRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getOrderLookupsRequest, "getOrderLookupsRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getProductDefinitionsRequest, "getProductDefinitionsRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getProductLookupsRequest, "getProductLookupsRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getProfileAttributeGroupsRequest, "getProfileAttributeGroupsRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getRequesterTasksInfoRequest, "getRequesterTasksInfoRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getScopeExtendedConfigurationRequest, "getScopeExtendedConfigurationRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getSupportedCulturesRequest, "getSupportedCulturesRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getTaskExecutionLogsRequest, "getTaskExecutionLogsRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getTaskInfoRequest, "getTaskInfoRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getTimeZonesRequest, "getTimeZonesRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getUserApplicationRequest, "getUserApplicationRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getUserCultureRequest, "getUserCultureRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getUserPermissionsRequest, "getUserPermissionsRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getUserScopeRequest, "getUserScopeRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getUserScopeTreeRequest, "getUserScopeTreeRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(getVersionInfoRequest, "getVersionInfoRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(saveUserApplicationRequest, "saveUserApplicationRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(saveUserCultureRequest, "saveUserCultureRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(signOutRequest, "signOutRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(updateCustomerLookupTypeDefinitionRequest, "updateCustomerLookupTypeDefinitionRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(updateEntityTypeRequest, "updateEntityTypeRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
  reactHotLoader.register(updateOrderLookupTypeDefinitionRequest, "updateOrderLookupTypeDefinitionRequest", "/home/vsts/work/1/s/src/actions/requestsApi.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();