"use strict";

exports.__esModule = true;
exports.getClickOutsideHandler = exports.default = exports.CloseButton = exports.AboutParagraph = exports.AboutLink = exports.AboutBox = exports.About = exports.ABOUT_NAME = void 0;
var _react = _interopRequireDefault(require("react"));
var _reactDom = _interopRequireDefault(require("react-dom"));
var _reactRedux = require("react-redux");
var _styledComponents = _interopRequireWildcard(require("styled-components"));
var _styledTransitionGroup = _interopRequireDefault(require("styled-transition-group"));
var _utils = require("../../utils");
var _Text = _interopRequireDefault(require("../Text"));
var _withClickOutside = _interopRequireDefault(require("../../hocs/withClickOutside"));
var _useViewState3 = _interopRequireDefault(require("../../hooks/useViewState"));
var _aboutBackground = _interopRequireDefault(require("../../content/aboutBackground.png"));
var _orckestraLogoWhite = _interopRequireDefault(require("../../content/orckestra-logo-white.png"));
var _close = _interopRequireDefault(require("../../content/close.png"));
var _versionInfo = require("../../selectors/versionInfo");
var _locale = require("../../selectors/locale");
var _sharedMessages = _interopRequireDefault(require("./../../sharedMessages"));
var _lodash = require("lodash");
var _templateObject;
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function _taggedTemplateLiteral(e, t) { return t || (t = e.slice(0)), Object.freeze(Object.defineProperties(e, { raw: { value: Object.freeze(t) } })); }
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var ABOUT_NAME = exports.ABOUT_NAME = "__aboutBox";
var getModalRoot = function getModalRoot() {
  return document.getElementById("modal");
};
var AboutBox = exports.AboutBox = (0, _withClickOutside.default)(_styledTransitionGroup.default.div(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n\tbox-sizing: border-box;\n\tz-index: 9999;\n\tposition: absolute;\n\ttop: calc(50% - 210px);\n\tleft: calc(50% - 210px);\n\theight: 420px;\n\twidth: 420px;\n\tpadding: 15px 20px;\n\tcolor: #ffffff;\n\tfont-size: 13px;\n\tline-height: 16px;\n\tbackground: #0a0a07 url(", ");\n\ttransition: opacity ", "ms ease-out;\n\n\t&:enter {\n\t\topacity: 0;\n\t}\n\t&:enter-active {\n\t\topacity: 1;\n\t}\n\t&:exit {\n\t\topacity: 1;\n\t}\n\t&:exit-active {\n\t\topacity: 0;\n\t}\n"])), _aboutBackground.default, function (props) {
  return props.timeout;
}));
AboutBox.defaultProps = {
  timeout: 800,
  unmountOnExit: true
};
var CloseButton = exports.CloseButton = _styledComponents.default.p.withConfig({
  displayName: "About__CloseButton",
  componentId: "sc-1y9zgcc-0"
})(["z-index:9999;position:absolute;color:#ffffff;top:15px;right:20px;margin:0;cursor:pointer;opacity:1;&:hover{opacity:0.75;}"]);
var AboutParagraph = exports.AboutParagraph = _styledComponents.default.p.withConfig({
  displayName: "About__AboutParagraph",
  componentId: "sc-1y9zgcc-1"
})(["margin-top:20px;", ""], (0, _utils.ifFlag)("long", (0, _styledComponents.css)(["html[lang^=\"fr\"] &{font-size:10px;}"])));
var AboutLink = exports.AboutLink = _styledComponents.default.a.withConfig({
  displayName: "About__AboutLink",
  componentId: "sc-1y9zgcc-2"
})(["color:#23527c;text-decoration:none;"]);
var getClickOutsideHandler = exports.getClickOutsideHandler = function getClickOutsideHandler(_ref, updateViewState) {
  var show = _ref.show;
  return show ? function (event) {
    event.stopPropagation();
    updateViewState("show", false);
  } : function () {};
};
var About = exports.About = function About(_ref2) {
  var currentApplication = _ref2.currentApplication;
  var _useViewState = (0, _useViewState3.default)(ABOUT_NAME),
    _useViewState2 = _slicedToArray(_useViewState, 2),
    viewState = _useViewState2[0],
    updateViewState = _useViewState2[1];
  var version = (0, _reactRedux.useSelector)(_versionInfo.getVersionSelector);
  var locale = (0, _reactRedux.useSelector)(_locale.currentLocaleOrDefault);
  var closeAboutBox = getClickOutsideHandler(viewState, updateViewState);
  var aboutLinkUrl = "https://www.orckestra.com".concat(locale.substr(0, 2).toLowerCase() === "fr" ? "/fr" : "");
  return /*#__PURE__*/_react.default.createElement(AboutBox, {
    in: viewState.show,
    onClickOutside: closeAboutBox
  }, /*#__PURE__*/_react.default.createElement(CloseButton, {
    onClick: closeAboutBox
  }, /*#__PURE__*/_react.default.createElement("img", {
    src: _close.default,
    alt: "X"
  })), /*#__PURE__*/_react.default.createElement("img", {
    src: _orckestraLogoWhite.default,
    width: "250",
    alt: "Orckestra"
  }), /*#__PURE__*/_react.default.createElement(AboutParagraph, null, /*#__PURE__*/_react.default.createElement(_Text.default, {
    message: _objectSpread(_objectSpread({}, _sharedMessages.default.ccVersion), {}, {
      values: {
        version: version
      }
    })
  }), currentApplication && currentApplication.displayName ? [/*#__PURE__*/_react.default.createElement("br", {
    key: "application-br"
  }), /*#__PURE__*/_react.default.createElement(_Text.default, {
    key: "application-version",
    message: currentApplication.displayName.concat(" ", window.BUILD_NUMBER)
  })] : null, DEPENDENCIES && DEPENDENCIES["orc-shared"] ? [/*#__PURE__*/_react.default.createElement("br", {
    key: "orc-shared-br"
  }), /*#__PURE__*/_react.default.createElement(_Text.default, {
    key: "orc-shared-version",
    message: _objectSpread(_objectSpread({}, _sharedMessages.default.orcSharedVersion), {}, {
      values: {
        version: (0, _lodash.trimStart)(DEPENDENCIES["orc-shared"], "^")
      }
    })
  })] : null, DEPENDENCIES && DEPENDENCIES["orc-scripts"] ? [/*#__PURE__*/_react.default.createElement("br", {
    key: "orc-scripts-br"
  }), /*#__PURE__*/_react.default.createElement(_Text.default, {
    key: "orc-scripts-version",
    message: _objectSpread(_objectSpread({}, _sharedMessages.default.orcScriptsVersion), {}, {
      values: {
        version: (0, _lodash.trimStart)(DEPENDENCIES["orc-scripts"], "^")
      }
    })
  })] : null, DEPENDENCIES && DEPENDENCIES["orc-secret"] ? [/*#__PURE__*/_react.default.createElement("br", {
    key: "orc-secret-br"
  }), /*#__PURE__*/_react.default.createElement(_Text.default, {
    key: "orc-secret-version",
    message: _objectSpread(_objectSpread({}, _sharedMessages.default.orcSecretVersion), {}, {
      values: {
        version: (0, _lodash.trimStart)(DEPENDENCIES["orc-secret"], "^")
      }
    })
  })] : null), /*#__PURE__*/_react.default.createElement(AboutParagraph, {
    long: true
  }, /*#__PURE__*/_react.default.createElement(_Text.default, {
    message: _sharedMessages.default.copyrightTermsNotice
  })), /*#__PURE__*/_react.default.createElement(AboutParagraph, null, /*#__PURE__*/_react.default.createElement(AboutLink, {
    href: aboutLinkUrl,
    target: "_blank"
  }, /*#__PURE__*/_react.default.createElement(_Text.default, {
    message: _sharedMessages.default.ccName
  }))), /*#__PURE__*/_react.default.createElement(AboutParagraph, null, /*#__PURE__*/_react.default.createElement(_Text.default, {
    message: _objectSpread(_objectSpread({}, _sharedMessages.default.copyright), {}, {
      values: {
        year: new Date().getFullYear()
      }
    })
  }), /*#__PURE__*/_react.default.createElement("br", null), /*#__PURE__*/_react.default.createElement(_Text.default, {
    message: _sharedMessages.default.allRightsReserved
  })));
};
__signature__(About, "useViewState{[viewState, updateViewState]}\nuseSelector{version}\nuseSelector{locale}", function () {
  return [_useViewState3.default, _reactRedux.useSelector, _reactRedux.useSelector];
});
__signature__(About, "useViewState{[viewState, updateViewState]}\nuseSelector{version}\nuseSelector{locale}", function () {
  return [_useViewState3.default, _reactRedux.useSelector, _reactRedux.useSelector];
});
var WiredAbout = About;
var _default = function _default(props) {
  return _reactDom.default.createPortal(/*#__PURE__*/_react.default.createElement(WiredAbout, props), getModalRoot());
};
var _default2 = _default;
var _default3 = exports.default = _default2;
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(ABOUT_NAME, "ABOUT_NAME", "/home/vsts/work/1/s/src/components/AppFrame/About.js");
  reactHotLoader.register(getModalRoot, "getModalRoot", "/home/vsts/work/1/s/src/components/AppFrame/About.js");
  reactHotLoader.register(AboutBox, "AboutBox", "/home/vsts/work/1/s/src/components/AppFrame/About.js");
  reactHotLoader.register(CloseButton, "CloseButton", "/home/vsts/work/1/s/src/components/AppFrame/About.js");
  reactHotLoader.register(AboutParagraph, "AboutParagraph", "/home/vsts/work/1/s/src/components/AppFrame/About.js");
  reactHotLoader.register(AboutLink, "AboutLink", "/home/vsts/work/1/s/src/components/AppFrame/About.js");
  reactHotLoader.register(getClickOutsideHandler, "getClickOutsideHandler", "/home/vsts/work/1/s/src/components/AppFrame/About.js");
  reactHotLoader.register(About, "About", "/home/vsts/work/1/s/src/components/AppFrame/About.js");
  reactHotLoader.register(WiredAbout, "WiredAbout", "/home/vsts/work/1/s/src/components/AppFrame/About.js");
  reactHotLoader.register(_default, "default", "/home/vsts/work/1/s/src/components/AppFrame/About.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(ABOUT_NAME, "ABOUT_NAME", "/home/vsts/work/1/s/src/components/AppFrame/About.js");
  reactHotLoader.register(getModalRoot, "getModalRoot", "/home/vsts/work/1/s/src/components/AppFrame/About.js");
  reactHotLoader.register(AboutBox, "AboutBox", "/home/vsts/work/1/s/src/components/AppFrame/About.js");
  reactHotLoader.register(CloseButton, "CloseButton", "/home/vsts/work/1/s/src/components/AppFrame/About.js");
  reactHotLoader.register(AboutParagraph, "AboutParagraph", "/home/vsts/work/1/s/src/components/AppFrame/About.js");
  reactHotLoader.register(AboutLink, "AboutLink", "/home/vsts/work/1/s/src/components/AppFrame/About.js");
  reactHotLoader.register(getClickOutsideHandler, "getClickOutsideHandler", "/home/vsts/work/1/s/src/components/AppFrame/About.js");
  reactHotLoader.register(About, "About", "/home/vsts/work/1/s/src/components/AppFrame/About.js");
  reactHotLoader.register(WiredAbout, "WiredAbout", "/home/vsts/work/1/s/src/components/AppFrame/About.js");
  reactHotLoader.register(_default2, "default", "/home/vsts/work/1/s/src/components/AppFrame/About.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();