"use strict";

exports.__esModule = true;
exports.default = exports.createGetUpdater = exports.clickOutsideHandler = exports.Wrapper = exports.Preferences = exports.PrefPanel = exports.PrefForm = exports.PrefButton = exports.PREFS_NAME = exports.Header = exports.Footer = void 0;
var _react = _interopRequireDefault(require("react"));
var _styledComponents = _interopRequireDefault(require("styled-components"));
var _reactRedux = require("react-redux");
var _utils = require("../../utils");
var _Sidepanel = _interopRequireDefault(require("../Sidepanel"));
var _Button = _interopRequireDefault(require("../Button"));
var _Text = _interopRequireDefault(require("../Text"));
var _Form = require("../Form/Form");
var _FieldElements = _interopRequireDefault(require("../Form/FieldElements"));
var _useViewState3 = _interopRequireDefault(require("../../hooks/useViewState"));
var _view = require("../../actions/view");
var _locale = require("../../actions/locale");
var _applications = require("../../actions/applications");
var _applications2 = require("../../selectors/applications");
var _locale2 = require("../../selectors/locale");
var _settings = require("../../selectors/settings");
var _withClickOutside = _interopRequireDefault(require("../../hocs/withClickOutside"));
var _versionInfo = require("../../actions/versionInfo");
var _sharedMessages = _interopRequireDefault(require("./../../sharedMessages"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var PREFS_NAME = exports.PREFS_NAME = "__prefsDialog";
var PrefPanel = exports.PrefPanel = (0, _styledComponents.default)(_Sidepanel.default).withConfig({
  displayName: "Preferences__PrefPanel",
  componentId: "sc-1fqlcmy-0"
})(["background-color:#f7f7f7;border-left:1px solid ", ";border-top:1px solid ", ";border-top-left-radius:5px;top:40px;box-shadow:-3px 2px 5px 0px rgba(0,0,0,0.2);z-index:9998;"], (0, _utils.getThemeProp)(["colors", "borderLight"], "#cccccc"), (0, _utils.getThemeProp)(["colors", "borderLight"], "#cccccc"));
var Wrapper = exports.Wrapper = (0, _withClickOutside.default)(_styledComponents.default.div.withConfig({
  displayName: "Preferences__Wrapper",
  componentId: "sc-1fqlcmy-1"
})(["display:flex;flex-direction:column;height:100%;"]));
var Header = exports.Header = _styledComponents.default.div.withConfig({
  displayName: "Preferences__Header",
  componentId: "sc-1fqlcmy-2"
})(["flex:0 0 auto;border-bottom:1px solid ", ";border-top-left-radius:5px;padding:15px 30px;height:18px;font-size:15px;font-family:", ";text-transform:uppercase;color:", ";background-color:#ffffff;"], (0, _utils.getThemeProp)(["colors", "borderLight"], "#cccccc"), (0, _utils.getThemeProp)(["fonts", "header"], "sans-serif"), (0, _utils.getThemeProp)(["colors", "application", "base"], "#ccc"));
var PrefForm = exports.PrefForm = _styledComponents.default.div.withConfig({
  displayName: "Preferences__PrefForm",
  componentId: "sc-1fqlcmy-3"
})(["flex:1 1 auto;display:flex;flex-direction:column;padding:20px 30px;font-size:12px;"]);
var Footer = exports.Footer = _styledComponents.default.div.withConfig({
  displayName: "Preferences__Footer",
  componentId: "sc-1fqlcmy-4"
})(["flex:0 0 auto;display:flex;align-items:center;justify-content:flex-end;background-color:#ffffff;border-top:1px solid ", ";padding-right:10px;height:60px;"], (0, _utils.getThemeProp)(["colors", "borderLight"], "#cccccc"));
var PrefButton = exports.PrefButton = (0, _styledComponents.default)(_Button.default).withConfig({
  displayName: "Preferences__PrefButton",
  componentId: "sc-1fqlcmy-5"
})(["margin-right:20px;min-width:110px;"]);
var createGetUpdater = exports.createGetUpdater = (0, _utils.memoize)(function (update) {
  return (0, _utils.memoize)(function (name) {
    return function (value) {
      return update(name, value);
    };
  });
});
var usePreferenceSetup = function usePreferenceSetup() {
  var dispatch = (0, _reactRedux.useDispatch)();
  var _useViewState = (0, _useViewState3.default)(PREFS_NAME),
    _useViewState2 = _slicedToArray(_useViewState, 2),
    viewState = _useViewState2[0],
    updateViewState = _useViewState2[1];
  return {
    show: viewState.show,
    values: _objectSpread({
      language: (0, _reactRedux.useSelector)(_locale2.currentLocaleOrDefault),
      application: (0, _reactRedux.useSelector)(_settings.defaultAppId) || ""
    }, viewState),
    getUpdater: createGetUpdater(updateViewState),
    languageOptions: (0, _utils.unwrapImmutable)((0, _reactRedux.useSelector)(_locale2.cultureOptionList)),
    applicationOptions: (0, _utils.unwrapImmutable)((0, _reactRedux.useSelector)(_applications2.localizedAppOptionSelector)),
    clear: function clear() {
      return dispatch((0, _view.setValue)(PREFS_NAME, {
        show: false
      }));
    },
    save: function save() {
      if (viewState.language) {
        dispatch((0, _locale.changeLocale)(viewState.language));
        dispatch((0, _locale.setDefaultLanguage)(viewState.language));
        dispatch((0, _versionInfo.resetVersionInfo)());
        // TODO: reload any language dependent data?
      }
      if (viewState.application) {
        dispatch((0, _applications.setMyApplication)(viewState.application));
      }
      dispatch((0, _view.setValue)(PREFS_NAME, {
        show: false
      }));
    }
  };
};
__signature__(usePreferenceSetup, "useDispatch{dispatch}\nuseViewState{[viewState, updateViewState]}\nuseSelector{}\nuseSelector{}\nuseSelector{}\nuseSelector{}", function () {
  return [_reactRedux.useDispatch, _useViewState3.default, _reactRedux.useSelector, _reactRedux.useSelector, _reactRedux.useSelector, _reactRedux.useSelector];
});
__signature__(usePreferenceSetup, "useDispatch{dispatch}\nuseViewState{[viewState, updateViewState]}\nuseSelector{}\nuseSelector{}\nuseSelector{}\nuseSelector{}", function () {
  return [_reactRedux.useDispatch, _useViewState3.default, _reactRedux.useSelector, _reactRedux.useSelector, _reactRedux.useSelector, _reactRedux.useSelector];
});
var clickOutsideHandler = exports.clickOutsideHandler = function clickOutsideHandler(e) {
  e.preventDefault();
  e.stopPropagation();
};
var Preferences = exports.Preferences = function Preferences() {
  var _usePreferenceSetup = usePreferenceSetup(),
    show = _usePreferenceSetup.show,
    getUpdater = _usePreferenceSetup.getUpdater,
    save = _usePreferenceSetup.save,
    clear = _usePreferenceSetup.clear,
    languageOptions = _usePreferenceSetup.languageOptions,
    applicationOptions = _usePreferenceSetup.applicationOptions,
    values = _usePreferenceSetup.values;
  return /*#__PURE__*/_react.default.createElement(PrefPanel, {
    in: show,
    width: "380px",
    timeout: 400
  }, /*#__PURE__*/_react.default.createElement(Wrapper, {
    onClickOutside: clickOutsideHandler
  }, /*#__PURE__*/_react.default.createElement(Header, null, /*#__PURE__*/_react.default.createElement(_Text.default, {
    message: _sharedMessages.default.preferences
  })), /*#__PURE__*/_react.default.createElement(PrefForm, null, /*#__PURE__*/_react.default.createElement(_Form.FormContext.Provider, {
    value: {
      values: values
    }
  }, /*#__PURE__*/_react.default.createElement(_FieldElements.default, {
    fields: [{
      label: _sharedMessages.default.displayLanguage,
      type: "Selector",
      name: "language",
      options: languageOptions
    }, {
      label: _sharedMessages.default.defaultApp,
      type: "Selector",
      name: "application",
      options: applicationOptions
    }],
    getUpdater: getUpdater
  }))), /*#__PURE__*/_react.default.createElement(Footer, null, /*#__PURE__*/_react.default.createElement(PrefButton, {
    id: "cancelPrefs",
    onClick: clear
  }, /*#__PURE__*/_react.default.createElement(_Text.default, {
    message: _sharedMessages.default.cancel
  })), /*#__PURE__*/_react.default.createElement(PrefButton, {
    id: "savePrefs",
    primary: true,
    onClick: save
  }, /*#__PURE__*/_react.default.createElement(_Text.default, {
    message: _sharedMessages.default.save
  })))));
};
__signature__(Preferences, "usePreferenceSetup{{ show, getUpdater, save, clear, languageOptions, applicationOptions, values }}", function () {
  return [usePreferenceSetup];
});
__signature__(Preferences, "usePreferenceSetup{{ show, getUpdater, save, clear, languageOptions, applicationOptions, values }}", function () {
  return [usePreferenceSetup];
});
var _default = Preferences;
var _default2 = _default;
var _default3 = exports.default = _default2;
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(PREFS_NAME, "PREFS_NAME", "/home/vsts/work/1/s/src/components/AppFrame/Preferences.js");
  reactHotLoader.register(PrefPanel, "PrefPanel", "/home/vsts/work/1/s/src/components/AppFrame/Preferences.js");
  reactHotLoader.register(Wrapper, "Wrapper", "/home/vsts/work/1/s/src/components/AppFrame/Preferences.js");
  reactHotLoader.register(Header, "Header", "/home/vsts/work/1/s/src/components/AppFrame/Preferences.js");
  reactHotLoader.register(PrefForm, "PrefForm", "/home/vsts/work/1/s/src/components/AppFrame/Preferences.js");
  reactHotLoader.register(Footer, "Footer", "/home/vsts/work/1/s/src/components/AppFrame/Preferences.js");
  reactHotLoader.register(PrefButton, "PrefButton", "/home/vsts/work/1/s/src/components/AppFrame/Preferences.js");
  reactHotLoader.register(createGetUpdater, "createGetUpdater", "/home/vsts/work/1/s/src/components/AppFrame/Preferences.js");
  reactHotLoader.register(usePreferenceSetup, "usePreferenceSetup", "/home/vsts/work/1/s/src/components/AppFrame/Preferences.js");
  reactHotLoader.register(clickOutsideHandler, "clickOutsideHandler", "/home/vsts/work/1/s/src/components/AppFrame/Preferences.js");
  reactHotLoader.register(Preferences, "Preferences", "/home/vsts/work/1/s/src/components/AppFrame/Preferences.js");
  reactHotLoader.register(_default, "default", "/home/vsts/work/1/s/src/components/AppFrame/Preferences.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(PREFS_NAME, "PREFS_NAME", "/home/vsts/work/1/s/src/components/AppFrame/Preferences.js");
  reactHotLoader.register(PrefPanel, "PrefPanel", "/home/vsts/work/1/s/src/components/AppFrame/Preferences.js");
  reactHotLoader.register(Wrapper, "Wrapper", "/home/vsts/work/1/s/src/components/AppFrame/Preferences.js");
  reactHotLoader.register(Header, "Header", "/home/vsts/work/1/s/src/components/AppFrame/Preferences.js");
  reactHotLoader.register(PrefForm, "PrefForm", "/home/vsts/work/1/s/src/components/AppFrame/Preferences.js");
  reactHotLoader.register(Footer, "Footer", "/home/vsts/work/1/s/src/components/AppFrame/Preferences.js");
  reactHotLoader.register(PrefButton, "PrefButton", "/home/vsts/work/1/s/src/components/AppFrame/Preferences.js");
  reactHotLoader.register(createGetUpdater, "createGetUpdater", "/home/vsts/work/1/s/src/components/AppFrame/Preferences.js");
  reactHotLoader.register(usePreferenceSetup, "usePreferenceSetup", "/home/vsts/work/1/s/src/components/AppFrame/Preferences.js");
  reactHotLoader.register(clickOutsideHandler, "clickOutsideHandler", "/home/vsts/work/1/s/src/components/AppFrame/Preferences.js");
  reactHotLoader.register(Preferences, "Preferences", "/home/vsts/work/1/s/src/components/AppFrame/Preferences.js");
  reactHotLoader.register(_default2, "default", "/home/vsts/work/1/s/src/components/AppFrame/Preferences.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();