"use strict";

exports.__esModule = true;
exports.default = exports.InputField = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactIntl = require("react-intl");
var _useViewState3 = _interopRequireDefault(require("../../hooks/useViewState"));
var _Form = require("./Form");
var _Inputs = _interopRequireDefault(require("./Inputs"));
var _Field = _interopRequireDefault(require("./Field"));
var _excluded = ["name", "type", "label", "labelOnly", "placeholder", "required"];
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var s = Object.getOwnPropertySymbols(e); for (r = 0; r < s.length; r++) o = s[r], t.includes(o) || {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (e.includes(n)) continue; t[n] = r[n]; } return t; }
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var InputField = exports.InputField = function InputField(_ref) {
  var name = _ref.name,
    _ref$type = _ref.type,
    type = _ref$type === void 0 ? "undefined" : _ref$type,
    label = _ref.label,
    labelOnly = _ref.labelOnly,
    placeholder = _ref.placeholder,
    required = _ref.required,
    props = _objectWithoutProperties(_ref, _excluded);
  var _useContext = (0, _react.useContext)(_Form.FormContext),
    values = _useContext.values,
    listIndex = _useContext.listIndex,
    formName = _useContext.formName;
  var fieldName = name;
  if (listIndex !== undefined) {
    fieldName += "[" + listIndex + "]";
  }
  var fullId = formName ? "".concat(formName, "_").concat(fieldName) : "field_".concat(fieldName);
  var _useViewState = (0, _useViewState3.default)(fullId),
    _useViewState2 = _slicedToArray(_useViewState, 2),
    wasBlurred = _useViewState2[0].wasBlurred,
    updateViewState = _useViewState2[1];
  var _values$name = values[name],
    value = _values$name === void 0 ? "" : _values$name;
  props.onBlur = (0, _react.useCallback)(function () {
    return updateViewState("wasBlurred", true);
  }, [updateViewState]);
  var _useIntl = (0, _reactIntl.useIntl)(),
    formatMessage = _useIntl.formatMessage;
  var Input = _Inputs.default[type];
  if (!Input) {
    console.error("Unknown type \"".concat(type, "\", cannot render field"));
    return /*#__PURE__*/_react.default.createElement("p", null, "Cannot render unknown type &", type, "&");
  }
  return /*#__PURE__*/_react.default.createElement(_Field.default, {
    id: fieldName,
    label: label,
    labelOnly: labelOnly,
    center: type === "SwitchInput" || type === "CheckboxInput",
    required: required,
    invalid: wasBlurred && required && !(Array.isArray(value) ? value.length : value)
  }, /*#__PURE__*/_react.default.createElement(Input, _extends({}, props, {
    id: fieldName,
    "aria-labelledby": listIndex !== undefined ? name + "_label" : undefined,
    "data-test-id": fullId,
    value: value,
    placeholder: typeof placeholder == "object" ? formatMessage(placeholder) : undefined,
    required: required && wasBlurred
  })));
};
__signature__(InputField, "useContext{{ values, listIndex, formName }}\nuseViewState{[{ wasBlurred }, updateViewState]}\nuseCallback{}\nuseIntl{{ formatMessage }}", function () {
  return [_useViewState3.default, _reactIntl.useIntl];
});
__signature__(InputField, "useContext{{ values, listIndex, formName }}\nuseViewState{[{ wasBlurred }, updateViewState]}\nuseCallback{}\nuseIntl{{ formatMessage }}", function () {
  return [_useViewState3.default, _reactIntl.useIntl];
});
var _default = InputField;
var _default2 = _default;
var _default3 = exports.default = _default2;
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(InputField, "InputField", "/home/vsts/work/1/s/src/components/Form/InputField.js");
  reactHotLoader.register(_default, "default", "/home/vsts/work/1/s/src/components/Form/InputField.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(InputField, "InputField", "/home/vsts/work/1/s/src/components/Form/InputField.js");
  reactHotLoader.register(_default2, "default", "/home/vsts/work/1/s/src/components/Form/InputField.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();