"use strict";

exports.__esModule = true;
exports.roundToStep = exports.NumberInput = void 0;
var _react = _interopRequireWildcard(require("react"));
var _Text = require("./Text");
var _FieldButtons = require("./FieldButtons");
var _excluded = ["update", "min", "max", "value", "step", "required"];
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var s = Object.getOwnPropertySymbols(e); for (r = 0; r < s.length; r++) o = s[r], t.includes(o) || {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (e.includes(n)) continue; t[n] = r[n]; } return t; }
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var roundToStep = exports.roundToStep = function roundToStep(num, step) {
  var parsedNum = parseFloat(num);
  if (Number.isNaN(parsedNum) || Number.isNaN(parseFloat(step))) {
    return "";
  }
  var factor = 1 / parseFloat(step);
  return Math.floor((parsedNum + 0.5 * step) * factor + Number.EPSILON) / factor;
};
var nullNaN = function nullNaN(num, nil) {
  if (nil === void 0) {
    nil = 0;
  }
  return Number.isNaN(num) ? nil : num;
};
var containNumber = function containNumber(number, max, min) {
  if (max === void 0) {
    max = Number.MAX_VALUE;
  }
  if (min === void 0) {
    min = -Number.MAX_VALUE;
  }
  return Number.isFinite(number) ? Math.min(max, Math.max(min, number)) : number;
};
var NumberInput = exports.NumberInput = function NumberInput(_ref) {
  var update = _ref.update,
    min = _ref.min,
    max = _ref.max,
    _ref$value = _ref.value,
    value = _ref$value === void 0 ? "" : _ref$value,
    step = _ref.step,
    required = _ref.required,
    props = _objectWithoutProperties(_ref, _excluded);
  var onChange = (0, _react.useCallback)(function (e) {
    return step ? update(containNumber(roundToStep(e.target.value, step), max, min)) : update(containNumber(nullNaN(parseFloat(e.target.value), ""), max, min));
  }, [update, step, min, max]);
  var increment = (0, _react.useCallback)(function () {
    return step ? update(containNumber(roundToStep(value + step, step), max, undefined)) : update(containNumber(nullNaN(parseFloat(value)) + 1, max, undefined));
  }, [update, value, step, max]);
  var decrement = (0, _react.useCallback)(function () {
    return step ? update(containNumber(roundToStep(value - step, step), undefined, min)) : update(containNumber(nullNaN(parseFloat(value)) - 1, undefined, min));
  }, [update, value, step, min]);
  return /*#__PURE__*/_react.default.createElement(_FieldButtons.ButtonWrapper, {
    invalid: required && !value
  }, /*#__PURE__*/_react.default.createElement(_Text.FormInput, _extends({
    type: "number",
    step: step,
    value: step ? roundToStep(value, step) : value,
    onChange: onChange
  }, props)), /*#__PURE__*/_react.default.createElement(_FieldButtons.Spinners, null, /*#__PURE__*/_react.default.createElement(_FieldButtons.InputButton, {
    onClick: increment,
    "data-test-id": "up"
  }, "\u2B9D"), /*#__PURE__*/_react.default.createElement(_FieldButtons.InputButton, {
    onClick: decrement,
    "data-test-id": "down"
  }, "\u2B9F")));
};
__signature__(NumberInput, "useCallback{onChange}\nuseCallback{increment}\nuseCallback{decrement}");
__signature__(NumberInput, "useCallback{onChange}\nuseCallback{increment}\nuseCallback{decrement}");
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(roundToStep, "roundToStep", "/home/vsts/work/1/s/src/components/Form/Inputs/Number.js");
  reactHotLoader.register(nullNaN, "nullNaN", "/home/vsts/work/1/s/src/components/Form/Inputs/Number.js");
  reactHotLoader.register(containNumber, "containNumber", "/home/vsts/work/1/s/src/components/Form/Inputs/Number.js");
  reactHotLoader.register(NumberInput, "NumberInput", "/home/vsts/work/1/s/src/components/Form/Inputs/Number.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(roundToStep, "roundToStep", "/home/vsts/work/1/s/src/components/Form/Inputs/Number.js");
  reactHotLoader.register(nullNaN, "nullNaN", "/home/vsts/work/1/s/src/components/Form/Inputs/Number.js");
  reactHotLoader.register(containNumber, "containNumber", "/home/vsts/work/1/s/src/components/Form/Inputs/Number.js");
  reactHotLoader.register(NumberInput, "NumberInput", "/home/vsts/work/1/s/src/components/Form/Inputs/Number.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();