"use strict";

exports.__esModule = true;
exports.default = exports.SmallButton = exports.RoundButton = exports.ButtonIcon = void 0;
var _react = _interopRequireDefault(require("react"));
var _styledComponents = _interopRequireDefault(require("styled-components"));
var _Button = _interopRequireDefault(require("../../Button"));
var _Icon = _interopRequireDefault(require("../../Icon"));
var _Tooltip = _interopRequireDefault(require("../../Tooltip"));
var _withId = _interopRequireDefault(require("../../../hocs/withId"));
var _excluded = ["id", "icon", "update", "aria-labelledby", "altText"];
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var s = Object.getOwnPropertySymbols(e); for (r = 0; r < s.length; r++) o = s[r], t.includes(o) || {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (e.includes(n)) continue; t[n] = r[n]; } return t; }
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var RoundButton = exports.RoundButton = (0, _styledComponents.default)(_Button.default).withConfig({
  displayName: "SmallButton__RoundButton",
  componentId: "sc-vey8bi-0"
})(["min-width:0;min-height:0;width:30px;height:30px;border-radius:50%;padding:6px;position:relative;"]);
var ButtonIcon = exports.ButtonIcon = (0, _styledComponents.default)(_Icon.default).withConfig({
  displayName: "SmallButton__ButtonIcon",
  componentId: "sc-vey8bi-1"
})(["font-size:16px;"]);
var SmallButton = exports.SmallButton = function SmallButton(_ref) {
  var id = _ref.id,
    icon = _ref.icon,
    update = _ref.update,
    aria = _ref["aria-labelledby"],
    _ref$altText = _ref.altText,
    altText = _ref$altText === void 0 ? "[altText]" : _ref$altText,
    props = _objectWithoutProperties(_ref, _excluded);
  return /*#__PURE__*/_react.default.createElement(RoundButton, _extends({
    id: id
  }, props, {
    onClick: update
  }), /*#__PURE__*/_react.default.createElement(ButtonIcon, {
    id: icon
  }), /*#__PURE__*/_react.default.createElement(_Tooltip.default, {
    message: altText
  }));
};
SmallButton.displayName = "SmallButton";
var _default = (0, _withId.default)("smallbutton")(SmallButton);
var _default2 = _default;
var _default3 = exports.default = _default2;
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(RoundButton, "RoundButton", "/home/vsts/work/1/s/src/components/Form/Inputs/SmallButton.js");
  reactHotLoader.register(ButtonIcon, "ButtonIcon", "/home/vsts/work/1/s/src/components/Form/Inputs/SmallButton.js");
  reactHotLoader.register(SmallButton, "SmallButton", "/home/vsts/work/1/s/src/components/Form/Inputs/SmallButton.js");
  reactHotLoader.register(_default, "default", "/home/vsts/work/1/s/src/components/Form/Inputs/SmallButton.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(RoundButton, "RoundButton", "/home/vsts/work/1/s/src/components/Form/Inputs/SmallButton.js");
  reactHotLoader.register(ButtonIcon, "ButtonIcon", "/home/vsts/work/1/s/src/components/Form/Inputs/SmallButton.js");
  reactHotLoader.register(SmallButton, "SmallButton", "/home/vsts/work/1/s/src/components/Form/Inputs/SmallButton.js");
  reactHotLoader.register(_default2, "default", "/home/vsts/work/1/s/src/components/Form/Inputs/SmallButton.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();