"use strict";

exports.__esModule = true;
exports.default = exports.Loading = void 0;
var _react = _interopRequireWildcard(require("react"));
var _component = _interopRequireDefault(require("@loadable/component"));
var _recompose = require("recompose");
var _withErrorBoundary = _interopRequireDefault(require("../hocs/withErrorBoundary"));
var _LoadingIcon = _interopRequireDefault(require("./LoadingIcon"));
var _ErrorPlaceholder = _interopRequireDefault(require("./ErrorPlaceholder"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var Loading = exports.Loading = function Loading(_ref) {
  var error = _ref.error;
  var _useState = (0, _react.useState)(false),
    _useState2 = _slicedToArray(_useState, 2),
    pastDelay = _useState2[0],
    flagDelay = _useState2[1];
  var timer = (0, _react.useRef)(null);
  (0, _react.useEffect)(function () {
    // Prevent refiring delay timeout
    if (!pastDelay && !timer.current) {
      timer.current = setTimeout(function () {
        return flagDelay(true);
      }, 200);
    }
    return function () {
      return clearTimeout(timer.current);
    };
  });
  if (error) {
    return /*#__PURE__*/_react.default.createElement(_ErrorPlaceholder.default, {
      message: error.message
    });
  } else if (pastDelay) {
    return /*#__PURE__*/_react.default.createElement(_LoadingIcon.default, null);
  } else {
    return null;
  }
};
__signature__(Loading, "useState{[pastDelay, flagDelay](false)}\nuseRef{timer}\nuseEffect{}");
__signature__(Loading, "useState{[pastDelay, flagDelay](false)}\nuseRef{timer}\nuseEffect{}");
var errorBoundary = (0, _recompose.compose)((0, _withErrorBoundary.default)("Loader"), (0, _recompose.branch)(function (_ref2) {
  var error = _ref2.error;
  return !!error;
}, (0, _recompose.renderComponent)(Loading)));
var Loader = function Loader(compLoader) {
  var Comp = (0, _component.default)(compLoader, {
    fallback: /*#__PURE__*/_react.default.createElement(Loading, null)
  });
  var BoundedComp = errorBoundary(Comp);
  BoundedComp.load = function () {
    return Comp.load();
  };
  return BoundedComp;
};
var _default = Loader;
var _default2 = _default;
var _default3 = exports.default = _default2;
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(Loading, "Loading", "/home/vsts/work/1/s/src/components/Loader.js");
  reactHotLoader.register(errorBoundary, "errorBoundary", "/home/vsts/work/1/s/src/components/Loader.js");
  reactHotLoader.register(Loader, "Loader", "/home/vsts/work/1/s/src/components/Loader.js");
  reactHotLoader.register(_default, "default", "/home/vsts/work/1/s/src/components/Loader.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(Loading, "Loading", "/home/vsts/work/1/s/src/components/Loader.js");
  reactHotLoader.register(errorBoundary, "errorBoundary", "/home/vsts/work/1/s/src/components/Loader.js");
  reactHotLoader.register(Loader, "Loader", "/home/vsts/work/1/s/src/components/Loader.js");
  reactHotLoader.register(_default2, "default", "/home/vsts/work/1/s/src/components/Loader.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();