"use strict";

exports.__esModule = true;
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _Collapse = _interopRequireDefault(require("@material-ui/core/Collapse"));
var _Icon = _interopRequireDefault(require("./Icon"));
var _styles = require("@material-ui/core/styles");
var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));
var _collapsableListProps2 = _interopRequireWildcard(require("./collapsableListProps"));
var _classnames = _interopRequireDefault(require("classnames"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var useStyles = (0, _styles.makeStyles)(function (theme) {
  return {
    container: {
      width: function width(props) {
        return props.containerWidth;
      }
    },
    toggleContainer: {
      display: "flex",
      alignItems: "center",
      cursor: "pointer",
      userSelect: "none",
      marginTop: theme.spacing(1)
    },
    floatLeft: {
      float: "left"
    },
    floatRight: {
      float: "right"
    },
    icon: {
      width: theme.spacing(1),
      height: theme.spacing(1),
      marginRight: theme.spacing(0.7)
    }
  };
});
var CollapsableList = function CollapsableList(_ref) {
  var _collapsableListProps;
  var defaultElement = _ref.defaultElement,
    otherElements = _ref.otherElements,
    collapsableListProps = _ref.collapsableListProps;
  if ((0, _collapsableListProps2.isCollapsableListProps)(collapsableListProps) === false) {
    throw new TypeError("collapsableListProps property is not of type CollapsableListProps");
  }
  var containerWidth = (_collapsableListProps = collapsableListProps == null ? void 0 : collapsableListProps.get(_collapsableListProps2.default.propNames.containerWidth)) != null ? _collapsableListProps : "fit-content";
  var classes = useStyles({
    containerWidth: containerWidth
  });
  var isExpanded = (collapsableListProps == null ? void 0 : collapsableListProps.get(_collapsableListProps2.default.propNames.isExpanded)) || false;
  var _useState = (0, _react.useState)(isExpanded),
    _useState2 = _slicedToArray(_useState, 2),
    open = _useState2[0],
    setOpen = _useState2[1];
  var handleClick = function handleClick() {
    setOpen(!open);
  };
  var hasMessage = (collapsableListProps == null ? void 0 : collapsableListProps.get(_collapsableListProps2.default.propNames.hasMessage)) || false;
  var closeMessage = (collapsableListProps == null ? void 0 : collapsableListProps.get(_collapsableListProps2.default.propNames.closeMessage)) || "";
  var openMessage = (collapsableListProps == null ? void 0 : collapsableListProps.get(_collapsableListProps2.default.propNames.openMessage)) || "";
  var expandPosition = collapsableListProps == null ? void 0 : collapsableListProps.get(_collapsableListProps2.default.propNames.expandPosition);
  var expandPositionClass = expandPosition === "right" ? classes.floatRight : classes.floatLeft;
  var message = open ? closeMessage : openMessage;
  var collapsableList = /*#__PURE__*/_react.default.createElement("div", {
    className: classes.container
  }, defaultElement, /*#__PURE__*/_react.default.createElement(_Collapse.default, {
    in: open,
    timeout: "auto"
  }, otherElements), /*#__PURE__*/_react.default.createElement("div", {
    onClick: function onClick() {
      return handleClick();
    },
    className: (0, _classnames.default)(classes.toggleContainer, expandPositionClass)
  }, /*#__PURE__*/_react.default.createElement(_Icon.default, {
    className: classes.icon,
    color: "primary",
    id: open ? "chevron-up" : "chevron-down"
  }), hasMessage ? /*#__PURE__*/_react.default.createElement(_Typography.default, {
    color: "primary",
    children: message
  }) : null));
  return collapsableList;
};
__signature__(CollapsableList, "useStyles{classes}\nuseState{[open, setOpen](isExpanded)}", function () {
  return [useStyles];
});
__signature__(CollapsableList, "useStyles{classes}\nuseState{[open, setOpen](isExpanded)}", function () {
  return [useStyles];
});
var _default = CollapsableList;
var _default2 = _default;
var _default3 = exports.default = _default2;
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(useStyles, "useStyles", "/home/vsts/work/1/s/src/components/MaterialUI/DataDisplay/CollapsableList.js");
  reactHotLoader.register(CollapsableList, "CollapsableList", "/home/vsts/work/1/s/src/components/MaterialUI/DataDisplay/CollapsableList.js");
  reactHotLoader.register(_default, "default", "/home/vsts/work/1/s/src/components/MaterialUI/DataDisplay/CollapsableList.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(useStyles, "useStyles", "/home/vsts/work/1/s/src/components/MaterialUI/DataDisplay/CollapsableList.js");
  reactHotLoader.register(CollapsableList, "CollapsableList", "/home/vsts/work/1/s/src/components/MaterialUI/DataDisplay/CollapsableList.js");
  reactHotLoader.register(_default2, "default", "/home/vsts/work/1/s/src/components/MaterialUI/DataDisplay/CollapsableList.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();