"use strict";

exports.__esModule = true;
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _styles = require("@material-ui/core/styles");
var _Grid = _interopRequireDefault(require("@material-ui/core/Grid"));
var _TransferList = require("./TransferList");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var useStyles = (0, _styles.makeStyles)(function (theme) {
  return {
    title: {
      color: theme.palette.text.hint,
      fontSize: theme.spacing(1.2),
      marginBottom: theme.spacing(0.6)
    },
    listHeight: {
      height: function height(props) {
        return props.height && theme.spacing(props.height);
      }
    },
    listHeightWithBorder: {
      height: function height(props) {
        return props.height && theme.spacing(props.height);
      },
      borderRight: "1px solid ".concat(theme.palette.grey.borders)
    },
    paper: {
      flexGrow: 1,
      height: "1px",
      // forces the container to takes 100%
      overflow: "auto",
      border: "1px solid ".concat(theme.palette.primary.light),
      borderRadius: theme.shape.borderRadius,
      boxShadow: "none",
      "&::-webkit-scrollbar": {
        width: theme.spacing(1.5)
      },
      "&::-webkit-scrollbar-thumb": {
        background: theme.palette.grey.borders,
        border: "5px white solid",
        backgroundClip: "padding-box",
        borderRadius: theme.spacing(1.5)
      }
    },
    paperLeft: {
      border: "1px solid ".concat(theme.palette.grey.borders)
    },
    actionPanel: {
      paddingTop: theme.spacing(2)
    },
    listContainer: {
      display: "flex",
      flexDirection: "column",
      height: "100%",
      boxSizing: "border-box"
    }
  };
});
var defaultInfoPanelXs = 6;
var formatOnChange = function formatOnChange(data, ids) {
  var selectedItems = data.filter(function (dataItem) {
    return ids.includes(dataItem.id);
  });
  return {
    selectedItems: [].concat(selectedItems)
  };
};
var SelectionList = function SelectionList(_ref) {
  var _infoPanelXs, _infoPanel;
  var listData = _ref.listData,
    onChange = _ref.onChange,
    listItemFormatter = _ref.listItemFormatter,
    onScroll = _ref.onScroll,
    currentTotal = _ref.currentTotal,
    _ref$currentPage = _ref.currentPage,
    currentPage = _ref$currentPage === void 0 ? 1 : _ref$currentPage,
    _ref$pageSize = _ref.pageSize,
    pageSize = _ref$pageSize === void 0 ? 20 : _ref$pageSize,
    _ref$height = _ref.height,
    height = _ref$height === void 0 ? 50 : _ref$height,
    _ref$multiSelect = _ref.multiSelect,
    multiSelect = _ref$multiSelect === void 0 ? false : _ref$multiSelect,
    defaultSelection = _ref.defaultSelection,
    infoPanel = _ref.infoPanel,
    infoPanelXs = _ref.infoPanelXs,
    _ref$divider = _ref.divider,
    divider = _ref$divider === void 0 ? true : _ref$divider,
    actionPanel = _ref.actionPanel;
  var classes = useStyles({
    height: height
  });
  var _useState = (0, _react.useState)([]),
    _useState2 = _slicedToArray(_useState, 2),
    checked = _useState2[0],
    setChecked = _useState2[1];
  var refScrollableList = _react.default.useRef();
  var defaultPanel = /*#__PURE__*/_react.default.createElement("div", null);
  (0, _react.useEffect)(function () {
    var listDataIds = listData.data.map(function (d) {
      return d.id;
    });
    var checkedFromList = listDataIds.filter(function (l) {
      return checked.includes(l);
    });
    if (defaultSelection && checkedFromList.length === 0 && checked[0] !== defaultSelection) {
      setChecked([defaultSelection]);
    }
  }, [defaultSelection, checked, listData.data]);
  (0, _react.useEffect)(function () {
    if (!multiSelect) {
      setChecked([defaultSelection]);
    }
  }, [defaultSelection, multiSelect, listData.data.length]);
  var onChangeEvent = function onChangeEvent(ids) {
    onChange && onChange(formatOnChange(listData.data, ids));
  };
  var showDivider = infoPanel && divider;
  infoPanelXs = (_infoPanelXs = infoPanelXs) != null ? _infoPanelXs : defaultInfoPanelXs;
  infoPanel = (_infoPanel = infoPanel) != null ? _infoPanel : defaultPanel;
  var listComponent = /*#__PURE__*/_react.default.createElement("div", {
    className: classes.listContainer
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: classes.title
  }, listData.title), /*#__PURE__*/_react.default.createElement(_TransferList.ScrollableCustomList, {
    ref: refScrollableList,
    onScroll: onScroll,
    currentPage: currentPage,
    currentTotal: currentTotal,
    pageSize: pageSize,
    classes: classes,
    items: listData.data,
    checked: checked,
    setChecked: setChecked,
    listItemFormatter: listItemFormatter,
    multiSelect: multiSelect,
    onChange: onChangeEvent
  }), actionPanel ? /*#__PURE__*/_react.default.createElement("div", {
    className: classes.actionPanel
  }, actionPanel) : null);
  return /*#__PURE__*/_react.default.createElement(_Grid.default, {
    container: true,
    spacing: 2
  }, /*#__PURE__*/_react.default.createElement(_Grid.default, {
    item: true,
    xs: 12 - infoPanelXs,
    className: showDivider ? classes.listHeightWithBorder : classes.listHeight
  }, listComponent), /*#__PURE__*/_react.default.createElement(_Grid.default, {
    item: true,
    xs: infoPanelXs
  }, infoPanel));
};
__signature__(SelectionList, "useStyles{classes}\nuseState{[checked, setChecked]([])}\nuseRef{refScrollableList}\nuseEffect{}\nuseEffect{}", function () {
  return [useStyles];
});
__signature__(SelectionList, "useStyles{classes}\nuseState{[checked, setChecked]([])}\nuseRef{refScrollableList}\nuseEffect{}\nuseEffect{}", function () {
  return [useStyles];
});
var _default = SelectionList;
var _default2 = _default;
var _default3 = exports.default = _default2;
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(useStyles, "useStyles", "/home/vsts/work/1/s/src/components/MaterialUI/DataDisplay/SelectionList.js");
  reactHotLoader.register(defaultInfoPanelXs, "defaultInfoPanelXs", "/home/vsts/work/1/s/src/components/MaterialUI/DataDisplay/SelectionList.js");
  reactHotLoader.register(formatOnChange, "formatOnChange", "/home/vsts/work/1/s/src/components/MaterialUI/DataDisplay/SelectionList.js");
  reactHotLoader.register(SelectionList, "SelectionList", "/home/vsts/work/1/s/src/components/MaterialUI/DataDisplay/SelectionList.js");
  reactHotLoader.register(_default, "default", "/home/vsts/work/1/s/src/components/MaterialUI/DataDisplay/SelectionList.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(useStyles, "useStyles", "/home/vsts/work/1/s/src/components/MaterialUI/DataDisplay/SelectionList.js");
  reactHotLoader.register(defaultInfoPanelXs, "defaultInfoPanelXs", "/home/vsts/work/1/s/src/components/MaterialUI/DataDisplay/SelectionList.js");
  reactHotLoader.register(formatOnChange, "formatOnChange", "/home/vsts/work/1/s/src/components/MaterialUI/DataDisplay/SelectionList.js");
  reactHotLoader.register(SelectionList, "SelectionList", "/home/vsts/work/1/s/src/components/MaterialUI/DataDisplay/SelectionList.js");
  reactHotLoader.register(_default2, "default", "/home/vsts/work/1/s/src/components/MaterialUI/DataDisplay/SelectionList.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();