"use strict";

exports.__esModule = true;
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _styles = require("@material-ui/core/styles");
var _classnames = _interopRequireDefault(require("classnames"));
var _textProps = _interopRequireWildcard(require("../../textProps"));
var _reactMultiClamp = _interopRequireDefault(require("react-multi-clamp"));
var _withDeferredTooltip = _interopRequireDefault(require("../../hocs/withDeferredTooltip"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var useStyles = (0, _styles.makeStyles)(function (theme) {
  return {
    clampedText: {
      wordBreak: "break-word"
    }
  };
});
var MultipleLinesText = function MultipleLinesText(_ref) {
  var children = _ref.children,
    titleValue = _ref.titleValue,
    textProps = _ref.textProps,
    tooltipClasses = _ref.tooltipClasses;
  var classes = useStyles();
  var _useState = (0, _react.useState)(false),
    _useState2 = _slicedToArray(_useState, 2),
    isClamped = _useState2[0],
    setIsClamped = _useState2[1];
  if ((0, _textProps.isTextProps)(textProps) === false) {
    throw new TypeError("textProps property is not of type TextProps");
  }
  var customStyles = textProps == null ? void 0 : textProps.get(_textProps.default.propNames.classes);
  var lineCount = (textProps == null ? void 0 : textProps.get(_textProps.default.propNames.lineCount)) || "auto";
  var title = titleValue == null ? children : titleValue;
  var TooltippedTextClamp = (0, _withDeferredTooltip.default)(_react.default.forwardRef(function (props, ref) {
    return /*#__PURE__*/_react.default.createElement(_reactMultiClamp.default, _extends({
      ref: ref
    }, props));
  }));
  var clampHandler = (0, _react.useCallback)(function (event) {
    if (isClamped === false && event.needClamp) {
      setIsClamped(true);
    }
  }, [isClamped, setIsClamped]);
  return /*#__PURE__*/_react.default.createElement(TooltippedTextClamp, {
    disableCssClamp: true,
    clamp: lineCount,
    className: (0, _classnames.default)(classes.clampedText, customStyles),
    children: children.toString(),
    titleValue: title,
    alwaysDisplay: isClamped,
    onClampStart: function onClampStart(event) {
      return clampHandler(event);
    },
    tooltipClasses: tooltipClasses
  });
};
__signature__(MultipleLinesText, "useStyles{classes}\nuseState{[isClamped, setIsClamped](false)}\nuseCallback{clampHandler}", function () {
  return [useStyles];
});
__signature__(MultipleLinesText, "useStyles{classes}\nuseState{[isClamped, setIsClamped](false)}\nuseCallback{clampHandler}", function () {
  return [useStyles];
});
var _default = MultipleLinesText;
var _default2 = _default;
var _default3 = exports.default = _default2;
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(useStyles, "useStyles", "/home/vsts/work/1/s/src/components/MaterialUI/DataDisplay/TooltippedElements/MultipleLinesText.js");
  reactHotLoader.register(MultipleLinesText, "MultipleLinesText", "/home/vsts/work/1/s/src/components/MaterialUI/DataDisplay/TooltippedElements/MultipleLinesText.js");
  reactHotLoader.register(_default, "default", "/home/vsts/work/1/s/src/components/MaterialUI/DataDisplay/TooltippedElements/MultipleLinesText.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(useStyles, "useStyles", "/home/vsts/work/1/s/src/components/MaterialUI/DataDisplay/TooltippedElements/MultipleLinesText.js");
  reactHotLoader.register(MultipleLinesText, "MultipleLinesText", "/home/vsts/work/1/s/src/components/MaterialUI/DataDisplay/TooltippedElements/MultipleLinesText.js");
  reactHotLoader.register(_default2, "default", "/home/vsts/work/1/s/src/components/MaterialUI/DataDisplay/TooltippedElements/MultipleLinesText.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();