"use strict";

exports.__esModule = true;
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactRedux = require("react-redux");
var _Backdrop = _interopRequireDefault(require("@material-ui/core/Backdrop"));
var _styles = require("@material-ui/core/styles");
var _CircularProgress = _interopRequireDefault(require("@material-ui/core/CircularProgress"));
var _requests = require("../../../selectors/requests");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var useStyles = (0, _styles.makeStyles)(function (theme) {
  return {
    backdrop: {
      zIndex: 9999
    },
    progress: {
      color: theme.palette.primary.main
    }
  };
});
var onMouseDownHandler = function onMouseDownHandler(event) {
  // We want to disable clicking on the backdrop, as it causes strange user selections to occur
  event.preventDefault();
  event.stopPropagation();
};
var LoadingScreen = function LoadingScreen() {
  var classes = useStyles();
  var loadingScreen = (0, _reactRedux.useSelector)(_requests.requestRunningSelector);
  var _useState = (0, _react.useState)(false),
    _useState2 = _slicedToArray(_useState, 2),
    progressState = _useState2[0],
    setProgressState = _useState2[1];
  (0, _react.useEffect)(function () {
    if (loadingScreen) {
      var timeout = setTimeout(function () {
        return setProgressState(true);
      }, 250);
      return function () {
        return clearTimeout(timeout);
      };
    }
    setProgressState(false);
  }, [loadingScreen, setProgressState]);
  return /*#__PURE__*/_react.default.createElement(_Backdrop.default, {
    "data-qa": "backdroploadingscreen",
    className: classes.backdrop,
    invisible: true,
    open: loadingScreen,
    onMouseDown: onMouseDownHandler
  }, progressState && /*#__PURE__*/_react.default.createElement(_CircularProgress.default, {
    className: classes.progress,
    size: 100,
    color: "inherit"
  }));
};
__signature__(LoadingScreen, "useStyles{classes}\nuseSelector{loadingScreen}\nuseState{[progressState, setProgressState](false)}\nuseEffect{}", function () {
  return [useStyles, _reactRedux.useSelector];
});
__signature__(LoadingScreen, "useStyles{classes}\nuseSelector{loadingScreen}\nuseState{[progressState, setProgressState](false)}\nuseEffect{}", function () {
  return [useStyles, _reactRedux.useSelector];
});
var _default = LoadingScreen;
var _default2 = _default;
var _default3 = exports.default = _default2;
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(useStyles, "useStyles", "/home/vsts/work/1/s/src/components/MaterialUI/Feedback/loadingScreen.js");
  reactHotLoader.register(onMouseDownHandler, "onMouseDownHandler", "/home/vsts/work/1/s/src/components/MaterialUI/Feedback/loadingScreen.js");
  reactHotLoader.register(LoadingScreen, "LoadingScreen", "/home/vsts/work/1/s/src/components/MaterialUI/Feedback/loadingScreen.js");
  reactHotLoader.register(_default, "default", "/home/vsts/work/1/s/src/components/MaterialUI/Feedback/loadingScreen.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(useStyles, "useStyles", "/home/vsts/work/1/s/src/components/MaterialUI/Feedback/loadingScreen.js");
  reactHotLoader.register(onMouseDownHandler, "onMouseDownHandler", "/home/vsts/work/1/s/src/components/MaterialUI/Feedback/loadingScreen.js");
  reactHotLoader.register(LoadingScreen, "LoadingScreen", "/home/vsts/work/1/s/src/components/MaterialUI/Feedback/loadingScreen.js");
  reactHotLoader.register(_default2, "default", "/home/vsts/work/1/s/src/components/MaterialUI/Feedback/loadingScreen.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();