"use strict";

exports.__esModule = true;
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _styles = require("@material-ui/core/styles");
var _Button = _interopRequireDefault(require("@material-ui/core/Button"));
var _Menu = _interopRequireDefault(require("@material-ui/core/Menu"));
var _MenuItem = _interopRequireDefault(require("@material-ui/core/MenuItem"));
var _Text = _interopRequireDefault(require("../../Text"));
var _DropDownMenuProps = _interopRequireWildcard(require("./DropDownMenuProps"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var useStyles = (0, _styles.makeStyles)(function (theme) {
  return {
    menuItem: {
      fontFamily: theme.typography.fontFamily,
      textTransform: "none",
      color: theme.palette.text.primary,
      borderRadius: 0,
      "&:hover": {
        borderRadius: 0,
        boxShadow: "none",
        backgroundColor: theme.palette.primary.light
      },
      "&:focus, &:active, &.Mui-focusVisible": {
        borderRadius: 0,
        boxShadow: "none",
        outline: "none"
      }
    },
    menu: {
      border: "".concat(theme.spacing(0.1), " solid ").concat(theme.palette.grey.borders),
      boxShadow: "".concat(theme.spacing(0, 0.5, 0.7, 0), " ").concat(theme.palette.grey.borders),
      borderRadius: theme.spacing(0.3)
    }
  };
});
var DropDownMenu = function DropDownMenu(_ref) {
  var payload = _ref.payload,
    menuItems = _ref.menuItems,
    children = _ref.children,
    _ref$dropDownMenuProp = _ref.dropDownMenuProps,
    dropDownMenuProps = _ref$dropDownMenuProp === void 0 ? new _DropDownMenuProps.default() : _ref$dropDownMenuProp;
  if ((0, _DropDownMenuProps.isDropDownMenuProps)(dropDownMenuProps) === false) {
    throw new TypeError("dropDownMenuProps property is not of type DropDownMenuProps");
  }
  var disabled = dropDownMenuProps.get(_DropDownMenuProps.default.propNames.disabled);
  var autoFocus = dropDownMenuProps.get(_DropDownMenuProps.default.propNames.autoFocus);
  var _useState = (0, _react.useState)(null),
    _useState2 = _slicedToArray(_useState, 2),
    anchorEl = _useState2[0],
    setAnchorEl = _useState2[1];
  var isOpened = Boolean(anchorEl);
  var classes = useStyles();
  var onClose = function onClose(event) {
    event.stopPropagation();
    setAnchorEl(null);
  };

  // Even though we do nothing, we need to avoid mouse event propagation when the mouse
  // button is released after hovering out the menu
  var onMainMenuClick = function onMainMenuClick(event) {
    event.preventDefault();
    event.stopPropagation();
  };
  var onMenuItemClick = function onMenuItemClick(action, itemContext) {
    return function (event) {
      onClose(event);
      action(payload, itemContext);
    };
  };
  var onOpenClick = function onOpenClick(event) {
    event.stopPropagation();
    setAnchorEl(event.currentTarget);
  };
  var buttonProps = {
    "aria-controls": "scope-menu",
    "aria-haspopup": true,
    onClick: onOpenClick,
    disabled: disabled
  };
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, (0, _react.isValidElement)(children) ? (0, _react.cloneElement)(children, buttonProps) : /*#__PURE__*/_react.default.createElement(_Button.default, buttonProps, children), /*#__PURE__*/_react.default.createElement(_Menu.default, {
    elevation: 0,
    getContentAnchorEl: null,
    anchorOrigin: {
      vertical: "bottom",
      horizontal: "right"
    },
    transformOrigin: {
      vertical: "top",
      horizontal: "right"
    },
    classes: {
      paper: classes.menu
    },
    id: "scope-menu",
    open: isOpened,
    onClick: onMainMenuClick,
    onClose: onClose,
    autoFocus: autoFocus,
    anchorEl: anchorEl
  }, menuItems.map(function (_ref2, key) {
    var title = _ref2.title,
      disabled = _ref2.disabled,
      action = _ref2.action,
      itemContext = _ref2.itemContext;
    return /*#__PURE__*/_react.default.createElement(_MenuItem.default, {
      classes: {
        root: classes.menuItem
      },
      key: key,
      onClick: onMenuItemClick(action, itemContext),
      disabled: disabled
    }, /*#__PURE__*/_react.default.createElement(_Text.default, {
      message: title
    }));
  })));
};
__signature__(DropDownMenu, "useState{[anchorEl, setAnchorEl](null)}\nuseStyles{classes}", function () {
  return [useStyles];
});
__signature__(DropDownMenu, "useState{[anchorEl, setAnchorEl](null)}\nuseStyles{classes}", function () {
  return [useStyles];
});
var _default = DropDownMenu;
var _default2 = _default;
var _default3 = exports.default = _default2;
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(useStyles, "useStyles", "/home/vsts/work/1/s/src/components/MaterialUI/Navigation/DropDownMenu.js");
  reactHotLoader.register(DropDownMenu, "DropDownMenu", "/home/vsts/work/1/s/src/components/MaterialUI/Navigation/DropDownMenu.js");
  reactHotLoader.register(_default, "default", "/home/vsts/work/1/s/src/components/MaterialUI/Navigation/DropDownMenu.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(useStyles, "useStyles", "/home/vsts/work/1/s/src/components/MaterialUI/Navigation/DropDownMenu.js");
  reactHotLoader.register(DropDownMenu, "DropDownMenu", "/home/vsts/work/1/s/src/components/MaterialUI/Navigation/DropDownMenu.js");
  reactHotLoader.register(_default2, "default", "/home/vsts/work/1/s/src/components/MaterialUI/Navigation/DropDownMenu.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();