"use strict";

exports.__esModule = true;
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _Tooltip = _interopRequireDefault(require("@material-ui/core/Tooltip"));
var _propertyValidator = require("../../../utils/propertyValidator");
var _excluded = ["titleValue", "alwaysDisplay", "tooltipClasses"];
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var s = Object.getOwnPropertySymbols(e); for (r = 0; r < s.length; r++) o = s[r], t.includes(o) || {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (e.includes(n)) continue; t[n] = r[n]; } return t; }
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
// Pay attention that if component you are passed to this HOC contains titleValue property
// by itself then that property will be disappeared after using that HOC.
// To fix it rename that property and pass titleValue just as a title for tooltip.

var withDeferredTooltip = function withDeferredTooltip(Comp) {
  return __signature__(__signature__(function (_ref) {
    var titleValue = _ref.titleValue,
      alwaysDisplay = _ref.alwaysDisplay,
      tooltipClasses = _ref.tooltipClasses,
      props = _objectWithoutProperties(_ref, _excluded);
    var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      shouldBeTooltipped = _useState2[0],
      setShouldBeTooltipped = _useState2[1];
    var defaultComponent = /*#__PURE__*/_react.default.createElement(Comp, _extends({
      onMouseEnter: function onMouseEnter(event) {
        return makeComponentTooltipped(event);
      }
    }, props));
    var makeComponentTooltipped = function makeComponentTooltipped(event) {
      if (alwaysDisplay) {
        setShouldBeTooltipped(true);
      } else {
        setShouldBeTooltipped(event.target.offsetWidth < event.target.scrollWidth);
      }
    };
    if (titleValue == null) return /*#__PURE__*/_react.default.createElement(Comp, props);
    if ((0, _propertyValidator.isString)(titleValue) && (0, _propertyValidator.isStringNullOrWhitespace)(titleValue)) return /*#__PURE__*/_react.default.createElement(Comp, props);
    if ((0, _propertyValidator.isObject)(titleValue) && (0, _propertyValidator.isReactComponent)(titleValue) === false) return /*#__PURE__*/_react.default.createElement(Comp, props);
    if (shouldBeTooltipped === false) return defaultComponent;
    return /*#__PURE__*/_react.default.createElement(_Tooltip.default, {
      arrow: true,
      classes: tooltipClasses != null ? tooltipClasses : null,
      title: titleValue,
      disableHoverListener: false,
      disableFocusListener: true,
      disableTouchListener: true
    }, defaultComponent);
  }, "useState{[shouldBeTooltipped, setShouldBeTooltipped](false)}"), "useState{[shouldBeTooltipped, setShouldBeTooltipped](false)}");
};
var _default = withDeferredTooltip;
var _default2 = _default;
var _default3 = exports.default = _default2;
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(withDeferredTooltip, "withDeferredTooltip", "/home/vsts/work/1/s/src/components/MaterialUI/hocs/withDeferredTooltip.js");
  reactHotLoader.register(_default, "default", "/home/vsts/work/1/s/src/components/MaterialUI/hocs/withDeferredTooltip.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(withDeferredTooltip, "withDeferredTooltip", "/home/vsts/work/1/s/src/components/MaterialUI/hocs/withDeferredTooltip.js");
  reactHotLoader.register(_default2, "default", "/home/vsts/work/1/s/src/components/MaterialUI/hocs/withDeferredTooltip.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();