"use strict";

exports.__esModule = true;
exports.default = void 0;
var _styles = require("@material-ui/core/styles");
var _colorManipulator = require("@material-ui/core/styles/colorManipulator");
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var drawerWidth = 240;
var commonTheme = {
  spacing: function spacing(factor) {
    return "".concat(0.625 * factor, "rem");
  },
  direction: "ltr",
  shape: {
    borderRadius: 4
  },
  indent: 3,
  typography: {
    h1Size: 24,
    h2Size: 18,
    h3Size: 16,
    h4Size: 14,
    h5Size: 13,
    h6Size: 13,
    fieldLabelSize: 12,
    htmlFontSize: 14,
    fontFamily: '"Open Sans", sans-serif',
    fontSize: 13,
    fontWeightThin: 100,
    fontWeightExtraLight: 200,
    fontWeightLight: 300,
    fontWeightRegular: 400,
    fontWeightMedium: 500,
    fontWeightSemiBold: 600,
    fontWeightBold: 700,
    fontWeightExtraBold: 800,
    fontWeightBlack: 900,
    button: {
      fontFamily: '"Roboto Condensed", sans-serif',
      fontWeight: 500,
      fontSize: 13,
      lineHeight: 1.0,
      letterSpacing: "0.0em",
      textTransform: "uppercase"
    }
  }
};
var commonPalette = {
  primary: {
    lighter: "#f5f5f5",
    light: "#CCC",
    main: "#232323",
    dark: "#000",
    contrastText: "#fff"
  },
  error: {
    light: "#FFBBAE",
    main: "#ED2E0B",
    dark: "#A13B38",
    contrastText: "#fff"
  },
  warning: {
    light: "#FEE8A0",
    main: "#F6C110",
    dark: "#AD9133",
    contrastText: "#fff"
  },
  success: {
    light: "#B9F0CB",
    main: "#10B246",
    dark: "#278045",
    contrastText: "#fff"
  },
  info: {
    light: "#93DDF9",
    main: "#0984B2",
    dark: "#1E708F",
    contrastText: "#fff"
  },
  grey: {
    darker: "#2D2D2D",
    dark: "#333",
    icon: "#999",
    borders: "#CCC",
    light: "#EFEFEF",
    lighter: "#F7F7F7"
  },
  text: {
    primary: "#333",
    secondary: "#575757",
    disabled: "#CCC",
    hint: "#999"
  },
  divider: "#CCCCCC",
  focus: "#4fa1f0",
  background: {
    paper: "#FFF",
    default: "#FFF",
    tabs: "#EFEFEF",
    app: "#333",
    selectedDate: "#216BA5"
  },
  action: {
    disabledBackground: "#EFEFEF"
  }
};
var setThemeProps = function setThemeProps(theme) {
  return _objectSpread(_objectSpread({}, theme.props), {}, {
    MuiButtonBase: {
      disableRipple: true
    },
    MuiTab: {
      disableRipple: true
    },
    MuiListItemText: {
      disableTypography: true
    }
  });
};
var setThemeOverrides = function setThemeOverrides(theme) {
  return _objectSpread(_objectSpread({}, theme.overrides), {}, {
    MuiButtonBase: _objectSpread(_objectSpread({}, theme.MuiButtonBase), {}, {
      root: _objectSpread(_objectSpread({}, theme.root), {}, {
        flexGrow: 0,
        backgroundColor: "transparent",
        borderColor: theme.palette.grey.borders,
        borderWidth: 1,
        boxSizing: "border-box",
        padding: theme.spacing(1, 2),
        borderRadius: theme.shape.borderRadius,
        color: theme.palette.text.primary,
        transition: theme.transitions.create(["background-color", "box-shadow", "border"], {
          duration: theme.transitions.duration.short
        }),
        "&:hover": {
          textDecoration: "none",
          backgroundColor: (0, _colorManipulator.alpha)(theme.palette.text.primary, theme.palette.action.hoverOpacity),
          // Reset on touch devices, it doesn't add specificity
          "@media (hover: none)": {
            backgroundColor: "transparent"
          },
          "&$disabled": {
            backgroundColor: "inherit",
            opacity: 0.4
          }
        },
        "&$disabled": {
          color: "inherit",
          opacity: 0.4
        },
        "&:focus, &:active, &.Mui-focusVisible": {
          borderRadius: theme.shape.borderRadius,
          borderColor: theme.palette.focus,
          boxShadow: "0 0 4px ".concat(theme.palette.focus),
          outline: "none"
        },
        "& + &": {
          marginLeft: theme.spacing(1)
        }
      })
    }),
    MuiLink: {
      root: {
        fontSize: theme.spacing(1.3)
      }
    },
    MuiButton: _objectSpread(_objectSpread({}, theme.MuiButton), {}, {
      root: {
        padding: "".concat(theme.spacing(0.8), " ").concat(theme.spacing(1)),
        height: theme.spacing(3),
        "&$disabled": {
          color: theme.palette.text.primary
        }
      },
      /* Styles applied to the span element that wraps the children. */
      label: _objectSpread(_objectSpread({}, theme.label), {}, {
        width: "100%",
        // Ensure the correct width for iOS Safari
        display: "inherit",
        alignItems: "inherit",
        justifyContent: "inherit",
        "& .MuiTypography-root": {
          fontFamily: theme.typography.button.fontFamily
        },
        "& .MuiSvgIcon-root": {
          fontSize: theme.spacing(2.1)
        }
      }),
      /* Styles applied to the root element if `variant="text"`. */
      text: _objectSpread(_objectSpread({}, theme.text), {}, {
        padding: theme.spacing(1)
      }),
      /* Styles applied to the root element if `variant="text"` and `color="primary"`. */
      textPrimary: {
        color: theme.palette.primary.main,
        "&:hover": {
          backgroundColor: (0, _colorManipulator.alpha)(theme.palette.primary.main, theme.palette.action.hoverOpacity),
          // Reset on touch devices, it doesn't add specificity
          "@media (hover: none)": {
            backgroundColor: "transparent"
          }
        }
      },
      /* Styles applied to the root element if `variant="text"` and `color="secondary"`. */
      textSecondary: {
        color: theme.palette.secondary.main,
        "&:hover": {
          backgroundColor: (0, _colorManipulator.alpha)(theme.palette.secondary.main, theme.palette.action.hoverOpacity),
          // Reset on touch devices, it doesn't add specificity
          "@media (hover: none)": {
            backgroundColor: "transparent"
          }
        }
      },
      /* Styles applied to the root element if `variant="outlined"`. */
      outlined: {
        padding: theme.spacing(0.5, 1),
        border: "1px solid ".concat(theme.palette.type === "light" ? theme.palette.grey.icon : theme.palette.grey.icon),
        backgroundColor: "white",
        "&$disabled": {
          border: "1px solid ".concat(theme.palette.type === "light" ? theme.palette.grey.icon : theme.palette.grey.icon)
        },
        "& path:not([fill='none'])": {
          fill: "currentColor"
        }
      },
      /* Styles applied to the root element if `variant="outlined"` and `color="primary"`. */
      outlinedPrimary: {
        color: theme.palette.primary.main,
        border: "1px solid ".concat(theme.palette.primary.main),
        backgroundColor: "white",
        "&:hover": {
          border: "1px solid ".concat(theme.palette.primary.main),
          backgroundColor: (0, _colorManipulator.alpha)(theme.palette.primary.main, theme.palette.action.hoverOpacity),
          // Reset on touch devices, it doesn't add specificity
          "@media (hover: none)": {
            backgroundColor: "transparent"
          }
        }
      },
      /* Styles applied to the root element if `variant="outlined"` and `color="secondary"`. */
      outlinedSecondary: {
        color: theme.palette.secondary.main,
        border: "1px solid ".concat(theme.palette.secondary.main),
        backgroundColor: "white",
        "&:hover": {
          border: "1px solid ".concat(theme.palette.secondary.main),
          backgroundColor: (0, _colorManipulator.alpha)(theme.palette.secondary.main, theme.palette.action.hoverOpacity),
          // Reset on touch devices, it doesn't add specificity
          "@media (hover: none)": {
            backgroundColor: "transparent"
          }
        },
        "&$disabled": {
          border: "1px solid ".concat(theme.palette.secondary.main)
        }
      },
      /* Styles applied to the root element if `variant="contained"`. */
      contained: {
        color: theme.palette.grey.dark,
        backgroundColor: theme.palette.grey.light,
        border: "1px solid ".concat(theme.palette.grey.icon),
        boxShadow: theme.shadows[2],
        "&:hover": {
          backgroundColor: "#D9D9D9",
          boxShadow: theme.shadows[4],
          // Reset on touch devices, it doesn't add specificity
          "@media (hover: none)": {
            boxShadow: theme.shadows[2],
            backgroundColor: theme.palette.grey.light
          },
          "&$disabled": {
            //backgroundColor: theme.palette.action.disabledBackground,
          }
        },
        "&$focusVisible": {},
        "&:active": {},
        "&$disabled": {
          color: theme.palette.action.disabled,
          boxShadow: theme.shadows[0],
          backgroundColor: theme.palette.action.disabledBackground
        }
      },
      /* Styles applied to the root element if `variant="contained"` and `color="primary"`. */
      containedPrimary: {
        color: theme.palette.primary.contrastText,
        backgroundColor: theme.palette.primary.main,
        border: "none",
        "&:hover": {
          backgroundColor: theme.palette.primary.dark,
          // Reset on touch devices, it doesn't add specificity
          "@media (hover: none)": {
            backgroundColor: theme.palette.primary.main
          }
        },
        "&.Mui-disabled": {
          backgroundColor: theme.palette.primary.main,
          color: theme.palette.primary.contrastText
        }
      },
      /* Styles applied to the root element if `variant="contained"` and `color="secondary"`. */
      containedSecondary: {
        color: theme.palette.secondary.contrastText,
        backgroundColor: theme.palette.secondary.main,
        "&:hover": {
          backgroundColor: theme.palette.secondary.dark,
          // Reset on touch devices, it doesn't add specificity
          "@media (hover: none)": {
            backgroundColor: theme.palette.secondary.main
          }
        }
      },
      /* Styles applied to the root element if `disableElevation={true}`. */
      disableElevation: {
        boxShadow: "none",
        "&:hover": {
          boxShadow: "none"
        },
        "&$focusVisible": {
          boxShadow: "none"
        },
        "&:active": {
          boxShadow: "none"
        },
        "&$disabled": {
          boxShadow: "none"
        }
      },
      /* Pseudo-class applied to the ButtonBase root element if the button is keyboard focused. */
      focusVisible: {},
      /* Pseudo-class applied to the root element if `disabled={true}`. */
      disabled: {},
      /* Styles applied to the root element if `color="inherit"`. */
      colorInherit: {
        color: "inherit",
        borderColor: "currentColor"
      },
      /* Styles applied to the root element if `size="small"` and `variant="text"`. */
      textSizeSmall: {
        padding: theme.spacing(0.4, 0.5),
        fontSize: theme.typography.pxToRem(13)
      },
      /* Styles applied to the root element if `size="large"` and `variant="text"`. */
      textSizeLarge: {
        padding: theme.spacing(0.8, 1.1),
        fontSize: theme.typography.pxToRem(15)
      },
      /* Styles applied to the root element if `size="small"` and `variant="outlined"`. */
      outlinedSizeSmall: {
        padding: theme.spacing(0.3, 0.9),
        fontSize: theme.typography.pxToRem(13)
      },
      /* Styles applied to the root element if `size="large"` and `variant="outlined"`. */
      outlinedSizeLarge: {
        padding: theme.spacing(0.7, 2.1),
        fontSize: theme.typography.pxToRem(15)
      },
      /* Styles applied to the root element if `size="small"` and `variant="contained"`. */
      containedSizeSmall: {
        padding: theme.spacing(0.4, 1),
        fontSize: theme.typography.pxToRem(13)
      },
      /* Styles applied to the root element if `size="large"` and `variant="contained"`. */
      containedSizeLarge: {
        padding: theme.spacing(0.8, 2.2),
        fontSize: theme.typography.pxToRem(15)
      },
      /* Styles applied to the root element if `size="small"`. */
      sizeSmall: {},
      /* Styles applied to the root element if `size="large"`. */
      sizeLarge: {},
      /* Styles applied to the root element if `fullWidth={true}`. */
      fullWidth: {
        width: "100%"
      },
      /* Styles applied to the startIcon element if supplied. */
      startIcon: {
        display: "inherit",
        marginRight: 8,
        marginLeft: -4,
        "&$iconSizeSmall": {
          marginLeft: -2
        }
      },
      /* Styles applied to the endIcon element if supplied. */
      endIcon: {
        display: "inherit",
        marginRight: -4,
        marginLeft: 8,
        "&$iconSizeSmall": {
          marginRight: -2
        }
      },
      /* Styles applied to the icon element if supplied and `size="small"`. */
      iconSizeSmall: {
        "& > *:first-child": {
          fontSize: 18
        }
      },
      /* Styles applied to the icon element if supplied and `size="medium"`. */
      iconSizeMedium: {
        "& > *:first-child": {
          fontSize: 20
        }
      },
      /* Styles applied to the icon element if supplied and `size="large"`. */
      iconSizeLarge: {
        "& > *:first-child": {
          fontSize: 22
        }
      }
    }),
    MuiSvgIcon: _objectSpread(_objectSpread({}, theme.MuiSvgIcon), {}, {
      root: _objectSpread(_objectSpread({}, theme.root), {}, {
        width: "1em",
        height: "1em",
        fill: "currentColor",
        stroke: "currentColor",
        color: theme.palette.grey.dark,
        "& path:not([fill='none'])": {
          fill: "currentColor"
        }
      }),
      colorPrimary: {
        color: theme.palette.primary.main
      },
      colorDisabled: {
        color: theme.palette.text.disabled
      }
    }),
    MuiIconButton: _objectSpread(_objectSpread({}, theme.MuiIconButton), {}, {
      root: _objectSpread(_objectSpread({}, theme.root), {}, {
        padding: theme.spacing(0.4, 1, 0.3, 1),
        color: theme.palette.grey.dark,
        borderRadius: theme.shape.borderRadius,
        minWidth: "auto",
        "& g:not([id*='Close']) path:not([fill='none'])": {
          fill: "currentColor"
        },
        "& + .MuiButton-root, & + .MuiIconButton-root, & + .MuiInputBase-root": {
          marginLeft: theme.spacing(1)
        },
        "&[variant='outlined']": {
          border: "1px solid ".concat(theme.palette.grey.icon),
          backgroundColor: theme.palette.background.default,
          "&:hover": {
            backgroundColor: theme.palette.grey.lighter
          }
        },
        "&[variant='contained']": {
          border: "1px solid ".concat(theme.palette.grey.icon),
          backgroundColor: theme.palette.grey.light,
          "&:hover": {
            backgroundColor: theme.palette.grey.borders
          }
        },
        "&[outlinecolor='primary']": {
          border: "1px solid ".concat(theme.palette.primary.main),
          backgroundColor: theme.palette.background.default,
          color: theme.palette.primary.main,
          "&:hover": {
            backgroundColor: theme.palette.primary.dark
          }
        }
      }),
      colorPrimary: {
        border: "1px solid ".concat(theme.palette.primary.main),
        backgroundColor: theme.palette.background.default,
        "&:hover": {
          backgroundColor: theme.palette.grey.lighter
        },
        "&[variant='contained']": {
          border: "1px solid ".concat(theme.palette.primary.main),
          backgroundColor: theme.palette.primary.main,
          color: theme.palette.primary.contrastText,
          "& .MuiSvgIcon-root": {
            color: theme.palette.primary.contrastText
          },
          "&:hover": {
            backgroundColor: theme.palette.primary.dark
          }
        },
        "&[variant='outlined']": {
          border: "1px solid ".concat(theme.palette.primary.main),
          backgroundColor: theme.palette.background.default,
          color: theme.palette.primary.main,
          "& .MuiSvgIcon-root": {
            color: theme.palette.primary.main
          },
          "&:hover": {
            backgroundColor: theme.palette.grey.lighter
          }
        }
      },
      label: _objectSpread(_objectSpread({}, theme.label), {}, {
        "& > .MuiSvgIcon-root": {
          maxHeight: theme.spacing(2.1)
        }
      })
    }),
    MuiDrawer: _objectSpread(_objectSpread({}, theme.MuiDrawer), {}, {
      root: _objectSpread(_objectSpread({}, theme.root), {}, {
        width: drawerWidth,
        flexShrink: 0,
        whiteSpace: "nowrap",
        "& .MuiListItemText-root": {
          opacity: 0,
          transition: theme.transitions.create("opacity", {
            easing: theme.transitions.easing.sharp,
            duration: theme.transitions.duration.enteringScreen
          })
        },
        /* To update with actual classnames if we change the side nav to use the MuiDrawer */
        "&[class*='drawerOpen'] .MuiListItemText-root": {
          opacity: 1,
          transition: theme.transitions.create("opacity", {
            easing: theme.transitions.easing.sharp,
            duration: theme.transitions.duration.enteringScreen
          })
        }
      }),
      paperAnchorDockedLeft: _objectSpread(_objectSpread({}, theme.paperAnchorDockedLeft), {}, {
        borderRight: "none"
      })
    }),
    MuiListItem: _objectSpread(_objectSpread({}, theme.MuiListItem), {}, {
      root: {
        "&.Mui-selected": {
          backgroundColor: theme.palette.primary.light
        },
        "& + &": {
          marginLeft: 0
        }
      },
      button: _objectSpread(_objectSpread({}, theme.button), {}, {
        color: theme.palette.grey.icon,
        "&:hover, &:hover .MuiListItemIcon-root, &hover .MuiListItemText-root": {
          color: theme.palette.primary.light
        }
      })
    }),
    MuiMenuItem: _objectSpread(_objectSpread({}, theme.MuiMenuItem), {}, {
      root: _objectSpread(_objectSpread(_objectSpread({}, theme.root), theme.typography.button), {}, {
        color: theme.palette.grey.dark,
        "&:hover, &:hover .MuiListItemIcon-root, &hover .MuiListItemText-root": {
          color: theme.palette.grey.dark
        }
      })
    }),
    MuiListItemIcon: _objectSpread(_objectSpread({}, theme.MuiListItemIcon), {}, {
      root: _objectSpread(_objectSpread({}, theme.root), {}, {
        color: theme.palette.grey.icon,
        minWidth: 0,
        padding: theme.spacing(0.5),
        marginRight: theme.spacing(0.5),
        "& path:not([fill='none'])": {
          fill: "currentColor"
        }
      })
    }),
    MuiTabs: _objectSpread(_objectSpread({}, theme.MuiTabs), {}, {
      root: _objectSpread(_objectSpread({}, theme.root), {}, {
        backgroundColor: theme.palette.grey.light,
        position: "relative",
        minHeight: "auto"
      }),
      indicator: _objectSpread(_objectSpread({}, theme.indicator), {}, {
        backgroundColor: "transparent"
      })
    }),
    MuiTab: _objectSpread(_objectSpread({}, theme.MuiTab), {}, {
      root: _objectSpread(_objectSpread({}, theme.root), {}, _defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty({
        backgroundColor: theme.palette.common.white,
        color: theme.palette.grey.light,
        border: "1px solid ".concat(theme.palette.grey.borders),
        borderRadius: theme.spacing(0.5, 0.5, 0, 0),
        zIndex: 10,
        height: theme.spacing(4.3),
        minHeight: theme.spacing(4.3),
        padding: "".concat(theme.spacing(1.4), " ").concat(theme.spacing(2)),
        textTransform: "uppercase",
        flexGrow: 0,
        borderBottom: "1px solid ".concat(theme.palette.primary.main)
      }, theme.breakpoints.up("sm"), {
        minWidth: 0
      }), "& .MuiIconButton-root", {
        padding: theme.spacing(0),
        flexGrow: 0,
        minWidth: 0,
        border: "none",
        "&:hover": {
          backgroundColor: "transparent"
        }
      }), "&.Mui-selected", {
        color: theme.palette.primary.main,
        borderColor: theme.palette.primary.main,
        borderBottom: "1px solid ".concat(theme.palette.common.white)
      }), "&.MuiTab-labelIcon svg", {
        marginRight: theme.spacing(1)
      }), "& .MuiTab-wrapper", {
        flexDirection: "row"
      }), "&.MuiButtonBase-root:focus, &.MuiButtonBase-root:active", {
        boxShadow: "none",
        borderRadius: "4px 4px 0 0"
      }), "& .MuiTypography-root", {
        fontFamily: theme.typography.button.fontFamily
      }), "& + &", {
        marginLeft: "0 !important"
      })),
      labelIcon: _objectSpread(_objectSpread({}, theme.labelIcon), {}, {
        minHeight: theme.spacing(4.3),
        padding: "".concat(theme.spacing(1.4), " ").concat(theme.spacing(2), " !important"),
        "& path:not([fill='none'])": {
          fill: "currentColor"
        },
        "& .MuiTab-wrapper > *:first-child": {
          marginBottom: theme.spacing(0)
        }
      })
    }),
    MuiTable: _objectSpread({}, theme.MuiTable),
    MuiTableHead: _objectSpread({}, theme.MuiTableHead),
    MuiTableRow: _objectSpread({}, theme.MuiTableRow),
    MuiTablePagination: {},
    MuiTableSortLabel: {},
    MuiTableFooter: _objectSpread(_objectSpread({}, theme.MuiTableFooter), {}, {
      root: _objectSpread(_objectSpread({}, theme.root), {}, {
        backgroundColor: theme.palette.grey.lighter
      })
    }),
    MuiInput: _objectSpread(_objectSpread({}, theme.MuiInput), {}, {
      underline: {
        border: "none",
        "&:before": {
          content: "none"
        }
      }
    }),
    MuiInputBase: _objectSpread(_objectSpread({}, theme.MuiInputBase), {}, {
      root: _objectSpread(_objectSpread({}, theme.root), {}, {
        width: "100%",
        "& + .MuiButton-root, & + .MuiIconButton-root, & + .MuiInputBase-root": {
          marginLeft: theme.spacing(1)
        }
      }),
      input: _objectSpread(_objectSpread({}, theme.input), {}, {
        borderRadius: theme.shape.borderRadius,
        position: "relative",
        backgroundColor: theme.palette.background.paper,
        border: "1px solid ".concat(theme.palette.grey.borders),
        fontSize: theme.typography.fontSize,
        minWidth: theme.spacing(14),
        padding: theme.spacing(0.6, 0.6, 0.6, 0.6),
        transition: theme.transitions.create(["border-color", "box-shadow"]),
        "&:focus, &:active": {
          borderRadius: theme.shape.borderRadius,
          borderColor: theme.palette.focus,
          boxShadow: "0 0 4px ".concat(theme.palette.focus),
          outline: "none"
        },
        "&[readonly]": {
          border: "none",
          backgroundColor: "transparent"
        },
        ".Mui-error &": {
          borderColor: theme.palette.error.main
        }
      }),
      adornedStart: {
        "& > .MuiOutlinedInput-root:first-child, & > .MuiButtonBase-root:first-child": {
          borderTopRightRadius: 0,
          borderBottomRightRadius: 0
        }
      },
      adornedEnd: {},
      inputAdornedStart: _objectSpread(_objectSpread({}, theme.inputAdornedStart), {}, {
        borderRight: "none",
        borderTopLeftRadius: 0,
        borderBottomLeftRadius: 0
      }),
      inputAdornedEnd: _objectSpread(_objectSpread({}, theme.inputAdornedEnd), {}, {
        borderLeft: "none",
        borderTopRightRadius: 0,
        borderBottomRightRadius: 0,
        "& + .MuiOutlinedInput-root, & + .MuiButtonBase-root": {
          borderTopLeftRadius: 0,
          borderBottomLeftRadius: 0
        }
      })
    }),
    MuiSelect: _objectSpread(_objectSpread({}, theme.MuiSelect), {}, {
      select: _objectSpread(_objectSpread({}, theme.select), {}, {
        minWidth: theme.spacing(13),
        borderRadius: theme.shape.borderRadius,
        "&.MuiSelect-select": {
          flexShrink: 1
        },
        "&:focus": {
          backgroundColor: theme.palette.background.paper
        }
      }),
      outlined: {
        padding: theme.spacing(0.4, 0.6, 0.4, 0.6)
      }
    }),
    MuiTypography: _objectSpread(_objectSpread({}, theme.MuiTypography), {}, {
      body1: _objectSpread(_objectSpread({}, theme.body1), {}, {
        fontSize: commonTheme.typography.fontSize,
        lineHeight: 1.3
      }),
      h1: _objectSpread(_objectSpread({}, theme.h1), {}, {
        fontSize: theme.typography.h1Size,
        fontWeight: theme.typography.fontWeightRegular,
        lineHeight: 1.3,
        color: theme.palette.grey.icon
      }),
      h2: _objectSpread(_objectSpread({}, theme.h2), {}, {
        fontSize: theme.typography.h2Size,
        fontWeight: theme.typography.fontWeightRegular,
        lineHeight: 1.3
      }),
      h3: _objectSpread(_objectSpread({}, theme.h3), {}, {
        fontSize: theme.typography.h3Size,
        fontWeight: theme.typography.fontWeightRegular,
        lineHeight: 1.3
      }),
      h4: _objectSpread(_objectSpread({}, theme.h4), {}, {
        fontSize: theme.typography.h4Size,
        fontWeight: theme.typography.fontWeightRegular,
        lineHeight: 1.3
      }),
      h5: _objectSpread(_objectSpread({}, theme.h5), {}, {
        fontSize: theme.typography.h5Size,
        fontWeight: theme.typography.fontWeightBold,
        lineHeight: 1.3
      }),
      h6: _objectSpread(_objectSpread({}, theme.h6), {}, {
        fontSize: theme.typography.h6Size,
        fontWeight: theme.typography.fontWeightSemiBold,
        lineHeight: 1.3
      })
    }),
    MuiCheckbox: _objectSpread(_objectSpread({}, theme.MuiCheckbox), {}, {
      root: _objectSpread(_objectSpread({}, theme.root), {}, {
        padding: theme.spacing(0.5, 0.5, 0.5, 0),
        minWidth: theme.spacing(3),
        backgroundColor: "inherit",
        border: "none",
        "&.Mui-checked": {
          "& .MuiSvgIcon-root": {
            color: "inherit"
          },
          "&:hover": {
            backgroundColor: "transparent !important"
          }
        },
        "&:hover": {
          backgroundColor: "transparent !important"
        },
        "&:focus, &:active": {
          boxShadow: "none"
        }
      }),
      colorPrimary: _objectSpread(_objectSpread({}, theme.colorPrimary), {}, {
        color: theme.palette.primary.main,
        "&.MuiCheckbox-indeterminate": {
          color: theme.palette.primary.main
        }
      })
    }),
    MuiAccordion: _objectSpread(_objectSpread({}, theme.MuiAccordion), {}, {
      root: _objectSpread(_objectSpread({}, theme.root), {}, {
        boxShadow: "none"
      })
    }),
    MuiAccordionSummary: _objectSpread(_objectSpread({}, theme.MuiAccordionSummary), {}, {
      expandIcon: _objectSpread(_objectSpread({}, theme.expandIcon), {}, {
        border: "none"
      })
    }),
    MuiTooltip: _objectSpread(_objectSpread({}, theme.MuiTooltip), {}, {
      tooltip: _objectSpread(_objectSpread({}, theme.tooltip), {}, {
        color: theme.palette.grey.dark,
        fontFamily: theme.typography.fontFamily,
        fontSize: theme.typography.fontSize,
        backgroundColor: theme.palette.background.paper,
        border: "1px solid",
        borderRadius: "3px",
        borderColor: theme.palette.grey.icon,
        boxShadow: "0 0 4px rgba(0,0,0,0.22)"
      }),
      arrow: _objectSpread(_objectSpread({}, theme.arrow), {}, {
        color: theme.palette.background.paper,
        "&:before": {
          border: "1px solid",
          borderColor: theme.palette.grey.icon
        }
      }),
      popper: _objectSpread(_objectSpread({}, theme.popper), {}, {
        zIndex: 10000
      })
    }),
    MuiRadio: _objectSpread(_objectSpread({}, theme.MuiRadio), {}, {
      root: _objectSpread(_objectSpread({}, theme.root), {}, {
        border: "none",
        backgroundColor: "transparent",
        "&.Mui-checked": {
          "& .MuiSvgIcon-root": {
            color: "inherit"
          },
          "&:hover": {
            backgroundColor: "transparent !important"
          }
        },
        "&:hover": {
          backgroundColor: "transparent !important"
        },
        "&:focus, &:active": {
          boxShadow: "none"
        }
      }),
      colorPrimary: _objectSpread(_objectSpread({}, theme.colorPrimary), {}, {
        "&:hover": {
          backgroundColor: "transparent !important"
        },
        "&.Mui-checked": {
          "&:hover": {
            backgroundColor: "transparent !important"
          }
        }
      }),
      colorSecondary: _objectSpread(_objectSpread({}, theme.colorSecondary), {}, {
        "&:hover": {
          backgroundColor: "transparent !important"
        },
        "&.Mui-checked": {
          "&:hover": {
            backgroundColor: "transparent !important"
          }
        }
      })
    }),
    MuiFormLabel: _objectSpread(_objectSpread({}, theme.MuiFormLabel), {}, {
      root: _objectSpread(_objectSpread({}, theme.root), {}, {
        fontSize: theme.typography.fieldLabelSize,
        color: theme.palette.grey.icon,
        "&.Mui-focused": {
          color: theme.palette.grey.icon
        }
      })
    }),
    MuiPaper: _objectSpread(_objectSpread({}, theme.MuiPaper), {}, {
      rounded: _objectSpread(_objectSpread({}, theme.rounded), {}, {
        borderRadius: "3px"
      }),
      outlined: _objectSpread(_objectSpread({}, theme.outlined), {}, {
        border: "1px solid ".concat(theme.palette.grey.borders)
      })
    }),
    MuiChip: _objectSpread(_objectSpread({}, theme.MuiChip), {}, {
      root: _objectSpread(_objectSpread({}, theme.root), {}, {
        height: theme.spacing(1.7),
        fontSize: theme.spacing(1.1),
        justifyContent: "left",
        texTransform: "capitalize",
        "&.Mui-disabled": {
          opacity: 1
        }
      }),
      label: _objectSpread(_objectSpread({}, theme.label), {}, {
        paddingLeft: theme.spacing(1),
        paddingRight: theme.spacing(1)
      })
    }),
    MuiTreeView: _objectSpread(_objectSpread({}, theme.MuiTreeView), {}, {
      root: {
        "& > li.MuiTreeItem-root:before": {
          borderTop: "none",
          left: theme.spacing(-1)
        },
        "& li:last-child:before": {
          height: "100%",
          bottom: 0,
          top: theme.spacing(1.2),
          backgroundColor: theme.palette.grey.light,
          marginLeft: "-1px"
        },
        "& > li > ul.MuiTreeItem-group:before": {
          left: theme.spacing(1)
        }
      }
    }),
    MuiTreeItem: _objectSpread(_objectSpread({}, theme.MuiTreeItem), {}, {
      root: _objectSpread(_objectSpread({}, theme.root), {}, {
        position: "relative",
        marginBottom: theme.spacing(1),
        "&:before ": {
          content: "\" \"",
          display: "block",
          position: "absolute",
          height: 0,
          borderTop: "1px solid ".concat(theme.palette.grey.icon),
          marginTop: "-1px",
          top: theme.spacing(1.2),
          left: theme.spacing(-2.1),
          width: theme.spacing(2)
        }
      }),
      label: _objectSpread(_objectSpread({}, theme.label), {}, {
        padding: 0
      }),
      content: _objectSpread(_objectSpread({}, theme.content), {}, {
        width: "auto",
        "& > .MuiTreeItem-label": {
          "&:hover": {
            backgroundColor: "".concat(theme.palette.primary.light)
          }
        }
      }),
      selected: _objectSpread(_objectSpread({}, theme.selected), {}, {
        "& > .MuiTreeItem-content .MuiTreeItem-label": {
          border: "1px solid ".concat(theme.palette.primary.main),
          backgroundColor: "".concat(theme.palette.primary.light, " !important")
        }
      }),
      group: _objectSpread(_objectSpread({}, theme.group), {}, {
        "&:before": {
          content: "\" \"",
          display: "block",
          width: 0,
          position: "absolute",
          top: theme.spacing(3.5),
          bottom: 0,
          borderLeft: "1px solid ".concat(theme.palette.grey.icon),
          left: theme.spacing(3)
        },
        "& > *": {
          marginLeft: theme.spacing(2),
          marginTop: theme.spacing(1.5)
        }
      }),
      iconContainer: _objectSpread(_objectSpread({}, theme.iconContainer), {}, {
        marginRight: theme.spacing(0.6),
        width: "auto",
        "& svg": {
          fontSize: "10px"
        },
        "&:before": {
          content: "\" \"",
          position: "absolute",
          height: theme.spacing(0.1),
          width: theme.spacing(0.5),
          left: theme.spacing(-0.5),
          backgroundColor: theme.palette.grey.light,
          top: theme.spacing(1.1)
        },
        "&:empty": {
          width: theme.spacing(1),
          "&:before": {
            backgroundColor: "transparent",
            borderTop: "1px solid ".concat(theme.palette.grey.icon),
            width: theme.spacing(1.5)
          }
        }
      })
    }),
    MuiTimeline: {
      root: _objectSpread(_objectSpread({}, theme.root), {}, {
        padding: 0,
        marginTop: 0
      })
    },
    MuiTimelineItem: {
      root: _objectSpread(_objectSpread({}, theme.root), {}, {
        minHeight: "auto"
      })
    },
    MuiTimelineContent: {
      root: _objectSpread(_objectSpread({}, theme.root), {}, {
        flex: 13,
        padding: theme.spacing(0, 2, 2),
        wordBreak: "break-word"
      })
    },
    MuiTimelineOppositeContent: {
      root: _objectSpread(_objectSpread({}, theme.root), {}, {
        flex: "2 0 0",
        padding: theme.spacing(0, 2, 2)
      })
    },
    MuiTimelineDot: {
      root: _objectSpread(_objectSpread({}, theme.root), {}, {
        marginTop: 0,
        marginBottom: 0,
        padding: theme.spacing(0.8),
        borderWidth: "1px"
      }),
      outlinedGrey: _objectSpread(_objectSpread({}, theme.outlinedGrey), {}, {
        borderColor: theme.palette.grey.icon
      })
    },
    MuiTimelineConnector: {
      root: _objectSpread(_objectSpread({}, theme.root), {}, {
        width: "1px",
        backgroundColor: theme.palette.grey.icon
      })
    }
  });
};
var createThemes = function createThemes(applicationTheme, themeDefinition) {
  var applicationMuiTheme = (0, _styles.createTheme)(applicationTheme);
  var muiTheme = (0, _styles.createTheme)(_objectSpread(_objectSpread(_objectSpread({}, commonTheme), themeDefinition), {}, {
    palette: _objectSpread(_objectSpread(_objectSpread({}, commonPalette), themeDefinition.palette), {}, {
      hoverprimary: {
        lighter: (0, _colorManipulator.darken)(themeDefinition.palette.primary.lighter, 0.05),
        light: (0, _colorManipulator.darken)(themeDefinition.palette.primary.light, 0.05),
        main: (0, _colorManipulator.darken)(themeDefinition.palette.primary.main, 0.05),
        dark: (0, _colorManipulator.darken)(themeDefinition.palette.primary.dark, 0.05)
      },
      hovererror: {
        light: (0, _colorManipulator.darken)(commonPalette.error.light, 0.05),
        main: (0, _colorManipulator.darken)(commonPalette.error.main, 0.05),
        dark: (0, _colorManipulator.darken)(commonPalette.error.dark, 0.05)
      },
      hoverwarning: {
        light: (0, _colorManipulator.darken)(commonPalette.warning.light, 0.05),
        main: (0, _colorManipulator.darken)(commonPalette.warning.main, 0.05),
        dark: (0, _colorManipulator.darken)(commonPalette.warning.dark, 0.05)
      },
      hoversuccess: {
        light: (0, _colorManipulator.darken)(commonPalette.success.light, 0.05),
        main: (0, _colorManipulator.darken)(commonPalette.success.main, 0.05),
        dark: (0, _colorManipulator.darken)(commonPalette.success.dark, 0.05)
      },
      hoverinfo: {
        light: (0, _colorManipulator.darken)(commonPalette.info.light, 0.05),
        main: (0, _colorManipulator.darken)(commonPalette.info.main, 0.05),
        dark: (0, _colorManipulator.darken)(commonPalette.info.dark, 0.05)
      },
      hovergrey: {
        darker: (0, _colorManipulator.darken)(commonPalette.grey.darker, 0.05),
        dark: (0, _colorManipulator.darken)(commonPalette.grey.dark, 0.05),
        icon: (0, _colorManipulator.darken)(commonPalette.grey.icon, 0.05),
        borders: (0, _colorManipulator.darken)(commonPalette.grey.borders, 0.05),
        light: (0, _colorManipulator.darken)(commonPalette.grey.light, 0.05),
        lighter: (0, _colorManipulator.darken)(commonPalette.grey.lighter, 0.05)
      }
    })
  }));
  muiTheme.props = setThemeProps(muiTheme);
  muiTheme.overrides = setThemeOverrides(muiTheme);
  return {
    applicationMuiTheme: applicationMuiTheme,
    muiTheme: muiTheme
  };
};
var _default = createThemes;
var _default2 = _default;
var _default3 = exports.default = _default2;
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(drawerWidth, "drawerWidth", "/home/vsts/work/1/s/src/components/MaterialUI/muiThemes.js");
  reactHotLoader.register(commonTheme, "commonTheme", "/home/vsts/work/1/s/src/components/MaterialUI/muiThemes.js");
  reactHotLoader.register(commonPalette, "commonPalette", "/home/vsts/work/1/s/src/components/MaterialUI/muiThemes.js");
  reactHotLoader.register(setThemeProps, "setThemeProps", "/home/vsts/work/1/s/src/components/MaterialUI/muiThemes.js");
  reactHotLoader.register(setThemeOverrides, "setThemeOverrides", "/home/vsts/work/1/s/src/components/MaterialUI/muiThemes.js");
  reactHotLoader.register(createThemes, "createThemes", "/home/vsts/work/1/s/src/components/MaterialUI/muiThemes.js");
  reactHotLoader.register(_default, "default", "/home/vsts/work/1/s/src/components/MaterialUI/muiThemes.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(drawerWidth, "drawerWidth", "/home/vsts/work/1/s/src/components/MaterialUI/muiThemes.js");
  reactHotLoader.register(commonTheme, "commonTheme", "/home/vsts/work/1/s/src/components/MaterialUI/muiThemes.js");
  reactHotLoader.register(commonPalette, "commonPalette", "/home/vsts/work/1/s/src/components/MaterialUI/muiThemes.js");
  reactHotLoader.register(setThemeProps, "setThemeProps", "/home/vsts/work/1/s/src/components/MaterialUI/muiThemes.js");
  reactHotLoader.register(setThemeOverrides, "setThemeOverrides", "/home/vsts/work/1/s/src/components/MaterialUI/muiThemes.js");
  reactHotLoader.register(createThemes, "createThemes", "/home/vsts/work/1/s/src/components/MaterialUI/muiThemes.js");
  reactHotLoader.register(_default2, "default", "/home/vsts/work/1/s/src/components/MaterialUI/muiThemes.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();