"use strict";

exports.__esModule = true;
exports.default = exports.SelectedValue = exports.MultiSelector = void 0;
var _react = _interopRequireWildcard(require("react"));
var _styledComponents = _interopRequireDefault(require("styled-components"));
var _utils = require("../utils");
var _withId = _interopRequireDefault(require("../hocs/withId"));
var _Text = _interopRequireDefault(require("./Text"));
var _ClickAwayListener = _interopRequireDefault(require("@material-ui/core/ClickAwayListener"));
var _Selector = require("./Selector");
var _excluded = ["id", "value", "options", "update", "selectAllMessage", "clearMessage", "placeholder", "required"];
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var s = Object.getOwnPropertySymbols(e); for (r = 0; r < s.length; r++) o = s[r], t.includes(o) || {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (e.includes(n)) continue; t[n] = r[n]; } return t; }
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var SelectedValue = exports.SelectedValue = _styledComponents.default.span.withConfig({
  displayName: "MultiSelector__SelectedValue",
  componentId: "sc-tl8y6p-0"
})(["display:inline-block;width:calc(100% - 20px);white-space:pre;overflow:hidden;"]);
var arrayToggle = function arrayToggle(arr, item) {
  var output = arr.filter(function (val) {
    return val !== item;
  });
  if (output.length < arr.length) {
    return output;
  }
  output.push(item);
  return output;
};
var labelFromOptions = function labelFromOptions(options) {
  return options.map(function (option) {
    return option.label;
  }).join(", ");
};
var MultiSelector = exports.MultiSelector = function MultiSelector(_ref) {
  var id = _ref.id,
    _ref$value = _ref.value,
    value = _ref$value === void 0 ? [] : _ref$value,
    options = _ref.options,
    update = _ref.update,
    _ref$selectAllMessage = _ref.selectAllMessage,
    selectAllMessage = _ref$selectAllMessage === void 0 ? "[Select all]" : _ref$selectAllMessage,
    _ref$clearMessage = _ref.clearMessage,
    clearMessage = _ref$clearMessage === void 0 ? "[Clear]" : _ref$clearMessage,
    _ref$placeholder = _ref.placeholder,
    placeholder = _ref$placeholder === void 0 ? "" : _ref$placeholder,
    required = _ref.required,
    props = _objectWithoutProperties(_ref, _excluded);
  var selectAll = (0, _react.useCallback)(function () {
    return update(options.map(function (opt) {
      return opt.value;
    }));
  }, [update, options]);
  var clearValue = (0, _react.useCallback)(function () {
    return update([]);
  }, [update]);
  // eslint-disable-next-line react-hooks/exhaustive-deps
  var clickOption = (0, _react.useCallback)((0, _utils.memoize)(function (clickValue) {
    return function () {
      return update(arrayToggle(value, clickValue));
    };
  }), [update, value]);
  var onChange = (0, _react.useCallback)(function (e) {
    return update(arrayToggle(value, e.target.value));
  }, [update, value]);
  var _useState = (0, _react.useState)(false),
    _useState2 = _slicedToArray(_useState, 2),
    isVisible = _useState2[0],
    setIsVisible = _useState2[1];
  /* istanbul ignore next */
  var toggleVisibility = function toggleVisibility() {
    setIsVisible(!isVisible);
  };

  /* istanbul ignore next */
  var handlerClickAway = function handlerClickAway() {
    setIsVisible(false);
  };

  /* istanbul ignore next */
  return /*#__PURE__*/_react.default.createElement(_ClickAwayListener.default, {
    onClickAway: function onClickAway() {
      return handlerClickAway();
    }
  }, /*#__PURE__*/_react.default.createElement(_Selector.Wrapper, null, /*#__PURE__*/_react.default.createElement(_Selector.InnerSelect, _extends({
    id: id,
    onChange: onChange,
    value: value,
    multiple: true,
    required: required
  }, props), options.map(function (option) {
    return /*#__PURE__*/_react.default.createElement("option", {
      key: option.value,
      value: option.value
    }, option.label);
  })), /*#__PURE__*/_react.default.createElement(_Selector.SelectBox, {
    htmlFor: id,
    onClick: function onClick() {
      return toggleVisibility();
    }
  }, value.length ? /*#__PURE__*/_react.default.createElement(SelectedValue, null, labelFromOptions(options.filter(function (option) {
    return value.indexOf(option.value) !== -1;
  }))) : /*#__PURE__*/_react.default.createElement(_Selector.Placeholder, null, placeholder)), /*#__PURE__*/_react.default.createElement(_Selector.Dropdown, {
    isVisible: isVisible
  }, value.length ? /*#__PURE__*/_react.default.createElement(_Selector.Option, {
    key: "multiselect_clear",
    onClick: clearValue,
    "data-test-id": "multiselect_clear"
  }, /*#__PURE__*/_react.default.createElement(_Text.default, {
    message: clearMessage
  })) : null, value.length === options.length ? null : /*#__PURE__*/_react.default.createElement(_Selector.Option, {
    key: "multiselect_selectAll",
    onClick: selectAll,
    "data-test-id": "multiselect_selectAll"
  }, /*#__PURE__*/_react.default.createElement(_Text.default, {
    message: selectAllMessage
  })), options.map(function (option) {
    return /*#__PURE__*/_react.default.createElement(_Selector.Option, {
      key: option.value,
      active: value.indexOf(option.value) !== -1,
      onClick: clickOption(option.value),
      "data-test-id": option.value
    }, option.label);
  }))));
};
__signature__(MultiSelector, "useCallback{selectAll}\nuseCallback{clearValue}\nuseCallback{clickOption}\nuseCallback{onChange}\nuseState{[isVisible, setIsVisible](false)}");
__signature__(MultiSelector, "useCallback{selectAll}\nuseCallback{clearValue}\nuseCallback{clickOption}\nuseCallback{onChange}\nuseState{[isVisible, setIsVisible](false)}");
var _default = (0, _withId.default)("selector")(MultiSelector);
var _default2 = _default;
var _default3 = exports.default = _default2;
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(SelectedValue, "SelectedValue", "/home/vsts/work/1/s/src/components/MultiSelector.js");
  reactHotLoader.register(arrayToggle, "arrayToggle", "/home/vsts/work/1/s/src/components/MultiSelector.js");
  reactHotLoader.register(labelFromOptions, "labelFromOptions", "/home/vsts/work/1/s/src/components/MultiSelector.js");
  reactHotLoader.register(MultiSelector, "MultiSelector", "/home/vsts/work/1/s/src/components/MultiSelector.js");
  reactHotLoader.register(_default, "default", "/home/vsts/work/1/s/src/components/MultiSelector.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(SelectedValue, "SelectedValue", "/home/vsts/work/1/s/src/components/MultiSelector.js");
  reactHotLoader.register(arrayToggle, "arrayToggle", "/home/vsts/work/1/s/src/components/MultiSelector.js");
  reactHotLoader.register(labelFromOptions, "labelFromOptions", "/home/vsts/work/1/s/src/components/MultiSelector.js");
  reactHotLoader.register(MultiSelector, "MultiSelector", "/home/vsts/work/1/s/src/components/MultiSelector.js");
  reactHotLoader.register(_default2, "default", "/home/vsts/work/1/s/src/components/MultiSelector.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();