"use strict";

exports.__esModule = true;
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactRouter = require("react-router");
var _withErrorBoundary = _interopRequireDefault(require("../../hocs/withErrorBoundary"));
var _FullPage = _interopRequireDefault(require("./FullPage"));
var _SubPage = _interopRequireDefault(require("./SubPage"));
var _withWaypointing = _interopRequireDefault(require("./withWaypointing"));
var _urlPattern = _interopRequireDefault(require("url-pattern"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var Page = function Page(_ref) {
  var View = _ref.component,
    path = _ref.path,
    _ref$pages = _ref.pages,
    pages = _ref$pages === void 0 ? {} : _ref$pages,
    _ref$subpages = _ref.subpages,
    subpages = _ref$subpages === void 0 ? {} : _ref$subpages,
    modulePrependPath = _ref.modulePrependPath,
    _ref$isVisible = _ref.isVisible,
    isVisible = _ref$isVisible === void 0 ? true : _ref$isVisible;
  var WrappedView = (0, _react.useMemo)(function () {
    return (0, _withErrorBoundary.default)(path)((0, _withWaypointing.default)(View, isVisible));
  }, [path, View, isVisible]);
  var parentUrlPattern = new _urlPattern.default(path);
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_reactRouter.Switch, null, Object.entries(pages).map(function (_ref2) {
    var _ref3 = _slicedToArray(_ref2, 2),
      subpath = _ref3[0],
      config = _ref3[1];
    return /*#__PURE__*/_react.default.createElement(_reactRouter.Route, {
      key: subpath,
      path: path + subpath,
      render: function render(route) {
        return /*#__PURE__*/_react.default.createElement(_FullPage.default, _extends({
          key: subpath,
          path: path + subpath,
          config: config
        }, route, {
          modulePrependPath: modulePrependPath
        }));
      }
    });
  }), /*#__PURE__*/_react.default.createElement(_reactRouter.Route, {
    key: "/",
    path: path,
    render: function render(route) {
      return /*#__PURE__*/_react.default.createElement(WrappedView, _extends({
        key: "/"
      }, route, {
        mapFrom: route.match.url,
        modulePrependPath: modulePrependPath
      }));
    }
  })), /*#__PURE__*/_react.default.createElement(_reactRouter.Switch, null, Object.entries(subpages).map(function (_ref4) {
    var _ref5 = _slicedToArray(_ref4, 2),
      subpath = _ref5[0],
      config = _ref5[1];
    return /*#__PURE__*/_react.default.createElement(_reactRouter.Route, {
      key: subpath,
      path: path + subpath,
      render: function render(route) {
        return /*#__PURE__*/_react.default.createElement(_SubPage.default, _extends({
          root: path,
          config: config,
          parentUrlPattern: parentUrlPattern
        }, route, {
          modulePrependPath: modulePrependPath
        }));
      }
    });
  })));
};
__signature__(Page, "useMemo{WrappedView}");
__signature__(Page, "useMemo{WrappedView}");
var _default = Page;
var _default2 = _default;
var _default3 = exports.default = _default2;
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(Page, "Page", "/home/vsts/work/1/s/src/components/Routing/Page.js");
  reactHotLoader.register(_default, "default", "/home/vsts/work/1/s/src/components/Routing/Page.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(Page, "Page", "/home/vsts/work/1/s/src/components/Routing/Page.js");
  reactHotLoader.register(_default2, "default", "/home/vsts/work/1/s/src/components/Routing/Page.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();