"use strict";

exports.__esModule = true;
exports.default = exports.ScopeText = exports.ScopeNode = exports.ScopeIcon = exports.ContentLabel = void 0;
var _react = _interopRequireDefault(require("react"));
var _styledComponents = _interopRequireWildcard(require("styled-components"));
var _Icon = _interopRequireDefault(require("../Icon"));
var _useScopeSelect3 = _interopRequireDefault(require("./useScopeSelect"));
var _utils = require("../../utils");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var ScopeIcon = exports.ScopeIcon = (0, _styledComponents.default)(_Icon.default).attrs(function (props) {
  return {
    id: (0, _utils.getThemeProp)(["icons", "scopeTypes", function (props) {
      return props.type;
    }], "cross")(props)
  };
}).withConfig({
  displayName: "ScopeNode__ScopeIcon",
  componentId: "sc-1o0tt5j-0"
})(["font-size:20px;vertical-align:middle;padding-right:8px;flex-shrink:0;color:", ";"], (0, _utils.getThemeProp)(["colors", "scopeTypes", function (props) {
  return props.type;
}], "inherit"));
var ScopeText = exports.ScopeText = _styledComponents.default.div.withConfig({
  displayName: "ScopeNode__ScopeText",
  componentId: "sc-1o0tt5j-1"
})(["overflow-wrap:break-word;"]);
var ContentLabel = exports.ContentLabel = _styledComponents.default.div.withConfig({
  displayName: "ScopeNode__ContentLabel",
  componentId: "sc-1o0tt5j-2"
})(["box-sizing:border-box;display:flex;align-items:center;padding:10px;width:100%;", ";", ";"], (0, _utils.ifFlag)("onClick", (0, _styledComponents.css)(["&:hover{background-color:#222;}"]), (0, _styledComponents.css)(["color:", ";cursor:default;"], (0, _utils.getThemeProp)(["colors", "textMedium"], "#999999"))), (0, _utils.ifFlag)("isGlobal", (0, _styledComponents.css)(["text-transform:uppercase;"])));
var ScopeNode = exports.ScopeNode = function ScopeNode(_ref) {
  var type = _ref.type,
    name = _ref.name,
    id = _ref.id,
    isAuthorizedScope = _ref.isAuthorizedScope,
    closeSelector = _ref.closeSelector;
  var _useScopeSelect = (0, _useScopeSelect3.default)(id),
    _useScopeSelect2 = _slicedToArray(_useScopeSelect, 1),
    navigate = _useScopeSelect2[0];
  var onClick = isAuthorizedScope && type !== "Virtual" ? function (event) {
    navigate(event);
    closeSelector(event);
  } : undefined;
  return /*#__PURE__*/_react.default.createElement(ContentLabel, {
    id: "selectorNode" + id,
    isGlobal: type === "Global",
    onClick: onClick
  }, /*#__PURE__*/_react.default.createElement(ScopeIcon, {
    type: type
  }), /*#__PURE__*/_react.default.createElement(ScopeText, null, name || id));
};
__signature__(ScopeNode, "useScopeSelect{[navigate]}", function () {
  return [_useScopeSelect3.default];
});
__signature__(ScopeNode, "useScopeSelect{[navigate]}", function () {
  return [_useScopeSelect3.default];
});
var _default = ScopeNode;
var _default2 = _default;
var _default3 = exports.default = _default2;
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(ScopeIcon, "ScopeIcon", "/home/vsts/work/1/s/src/components/Scope/ScopeNode.js");
  reactHotLoader.register(ScopeText, "ScopeText", "/home/vsts/work/1/s/src/components/Scope/ScopeNode.js");
  reactHotLoader.register(ContentLabel, "ContentLabel", "/home/vsts/work/1/s/src/components/Scope/ScopeNode.js");
  reactHotLoader.register(ScopeNode, "ScopeNode", "/home/vsts/work/1/s/src/components/Scope/ScopeNode.js");
  reactHotLoader.register(_default, "default", "/home/vsts/work/1/s/src/components/Scope/ScopeNode.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(ScopeIcon, "ScopeIcon", "/home/vsts/work/1/s/src/components/Scope/ScopeNode.js");
  reactHotLoader.register(ScopeText, "ScopeText", "/home/vsts/work/1/s/src/components/Scope/ScopeNode.js");
  reactHotLoader.register(ContentLabel, "ContentLabel", "/home/vsts/work/1/s/src/components/Scope/ScopeNode.js");
  reactHotLoader.register(ScopeNode, "ScopeNode", "/home/vsts/work/1/s/src/components/Scope/ScopeNode.js");
  reactHotLoader.register(_default2, "default", "/home/vsts/work/1/s/src/components/Scope/ScopeNode.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();