"use strict";

exports.__esModule = true;
exports.default = exports.Wrapper = exports.Selector = exports.SelectedValue = exports.SelectBox = exports.Placeholder = exports.Option = exports.InnerSelect = exports.Dropdown = void 0;
var _react = _interopRequireWildcard(require("react"));
var _styledComponents = _interopRequireWildcard(require("styled-components"));
var _utils = require("../utils");
var _withId = _interopRequireDefault(require("../hocs/withId"));
var _ClickAwayListener = _interopRequireDefault(require("@material-ui/core/ClickAwayListener"));
var _excluded = ["id", "value", "options", "update", "placeholder", "required"];
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var s = Object.getOwnPropertySymbols(e); for (r = 0; r < s.length; r++) o = s[r], t.includes(o) || {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (e.includes(n)) continue; t[n] = r[n]; } return t; }
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var InnerSelect = exports.InnerSelect = _styledComponents.default.select.withConfig({
  displayName: "Selector__InnerSelect",
  componentId: "sc-2v9pm-0"
})(["position:absolute;opacity:0;font-size:0;height:0;width:0;border:0 none transparent;z-index:-1;transform:translateX(-99px);"]);
var Wrapper = exports.Wrapper = _styledComponents.default.div.withConfig({
  displayName: "Selector__Wrapper",
  componentId: "sc-2v9pm-1"
})(["position:relative;cursor:pointer;font-size:12px;max-width:700px;"]);
var SelectBox = exports.SelectBox = _styledComponents.default.label.withConfig({
  displayName: "Selector__SelectBox",
  componentId: "sc-2v9pm-2"
})(["position:relative;box-sizing:border-box;display:block;min-height:30px;max-height:70px;overflow:hidden;padding:5px 10px;border:1px solid ", ";border-radius:4px;background-color:white;&::before{content:\" \";position:absolute;top:0;bottom:0;right:0;left:0;box-shadow:0 -10px 5px -5px inset white;}&::after{content:\"\u02C7\";font-family:courier,monospace;font-size:32px;position:absolute;right:10px;top:6px;}", ":focus + &{border-color:#4fa1f0;box-shadow:0 0 4px #4fa1f0;}", ":focus + &::after{transform:rotate(0.5turn);transform-origin:center 8px;}", ":invalid + &{border-color:", ";box-shadow:0 0 4px ", ";}"], (0, _utils.getThemeProp)(["colors", "borderLight"], "#cccccc"), InnerSelect, InnerSelect, InnerSelect, (0, _utils.getThemeProp)(["colors", "error"], "#ce4844"), (0, _utils.getThemeProp)(["colors", "error"], "#ce4844"));
var SelectedValue = exports.SelectedValue = _styledComponents.default.span.withConfig({
  displayName: "Selector__SelectedValue",
  componentId: "sc-2v9pm-3"
})(["display:inline-block;width:calc(100% - 20px);white-space:pre;overflow:hidden;"]);
var Dropdown = exports.Dropdown = _styledComponents.default.div.withConfig({
  displayName: "Selector__Dropdown",
  componentId: "sc-2v9pm-4"
})(["box-sizing:border-box;position:absolute;left:0;top:calc(100% + 1px);z-index:1;border:1px solid ", ";border-radius:4px;padding:4px 0;width:100%;max-height:40vh;overflow-y:auto;background-color:white;opacity:0;visibility:hidden;", ";transition:visibility 0.4s step-end;", ""], (0, _utils.getThemeProp)(["colors", "borderLight"], "#cccccc"), /* Enables click handling on Options while closing dropdown */"", function (props) {
  /* istanbul ignore next */
  if (props.isVisible) {
    return "".concat(InnerSelect, " + ").concat(SelectBox, " + & {\n\t\t\t\topacity: 1;\n\t\t\t\tvisibility: visible;\n\t\t\t\ttransition: visibility 0s step-end;\n\t\t\t}");
  }
});
var Option = exports.Option = _styledComponents.default.div.withConfig({
  displayName: "Selector__Option",
  componentId: "sc-2v9pm-5"
})(["box-sizing:border-box;height:30px;padding:6px 12px;white-space:pre;", ";&:hover{background-color:", ";color:#ffffff;}"], (0, _utils.ifFlag)("active", (0, _styledComponents.css)(["background-color:#f0f0f0;"])), (0, _utils.getThemeProp)(["colors", "application", "base"], "#ccc"));
var Placeholder = exports.Placeholder = _styledComponents.default.span.withConfig({
  displayName: "Selector__Placeholder",
  componentId: "sc-2v9pm-6"
})(["color:rgb(117,117,117);"]);
var Selector = exports.Selector = function Selector(_ref) {
  var id = _ref.id,
    value = _ref.value,
    options = _ref.options,
    update = _ref.update,
    _ref$placeholder = _ref.placeholder,
    placeholder = _ref$placeholder === void 0 ? "" : _ref$placeholder,
    required = _ref.required,
    props = _objectWithoutProperties(_ref, _excluded);
  // eslint-disable-next-line react-hooks/exhaustive-deps
  var clickOption = (0, _react.useCallback)((0, _utils.memoize)(function (value) {
    return function () {
      update(value);
      setIsVisible(false);
    };
  }), [update]);
  console.warn("Selector component has been deprecated in favor of Material-UI wrapper component Select");
  var onChange = (0, _react.useCallback)(function (e) {
    return update(e.target.value);
  }, [update]);
  var _useState = (0, _react.useState)(false),
    _useState2 = _slicedToArray(_useState, 2),
    isVisible = _useState2[0],
    setIsVisible = _useState2[1];
  /* istanbul ignore next */
  var toggleVisibility = function toggleVisibility() {
    setIsVisible(!isVisible);
  };

  /* istanbul ignore next */
  var handlerClickAway = function handlerClickAway() {
    setIsVisible(false);
  };

  /* istanbul ignore next */
  return /*#__PURE__*/_react.default.createElement(_ClickAwayListener.default, {
    onClickAway: function onClickAway() {
      return handlerClickAway();
    }
  }, /*#__PURE__*/_react.default.createElement(Wrapper, null, /*#__PURE__*/_react.default.createElement(InnerSelect, _extends({
    id: id,
    onChange: onChange,
    value: value,
    required: required
  }, props), required ? /*#__PURE__*/_react.default.createElement("option", null) : null, options.map(function (option) {
    return /*#__PURE__*/_react.default.createElement("option", {
      key: option.value,
      value: option.value
    }, option.label);
  })), /*#__PURE__*/_react.default.createElement(SelectBox, {
    htmlFor: id,
    onClick: function onClick() {
      return toggleVisibility();
    }
  }, value ? /*#__PURE__*/_react.default.createElement(SelectedValue, null, options.filter(function (option) {
    return option.value === value;
  }).map(function (option) {
    return option.label;
  })[0]) : /*#__PURE__*/_react.default.createElement(Placeholder, null, placeholder)), /*#__PURE__*/_react.default.createElement(Dropdown, {
    isVisible: isVisible
  }, options.map(function (option) {
    return /*#__PURE__*/_react.default.createElement(Option, {
      key: option.value,
      active: option.value === value,
      onClick: clickOption(option.value),
      "data-test-id": option.value
    }, option.label);
  }))));
};
__signature__(Selector, "useCallback{clickOption}\nuseCallback{onChange}\nuseState{[isVisible, setIsVisible](false)}");
__signature__(Selector, "useCallback{clickOption}\nuseCallback{onChange}\nuseState{[isVisible, setIsVisible](false)}");
var _default = (0, _withId.default)("selector")(Selector);
var _default2 = _default;
var _default3 = exports.default = _default2;
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(InnerSelect, "InnerSelect", "/home/vsts/work/1/s/src/components/Selector.js");
  reactHotLoader.register(Wrapper, "Wrapper", "/home/vsts/work/1/s/src/components/Selector.js");
  reactHotLoader.register(SelectBox, "SelectBox", "/home/vsts/work/1/s/src/components/Selector.js");
  reactHotLoader.register(SelectedValue, "SelectedValue", "/home/vsts/work/1/s/src/components/Selector.js");
  reactHotLoader.register(Dropdown, "Dropdown", "/home/vsts/work/1/s/src/components/Selector.js");
  reactHotLoader.register(Option, "Option", "/home/vsts/work/1/s/src/components/Selector.js");
  reactHotLoader.register(Placeholder, "Placeholder", "/home/vsts/work/1/s/src/components/Selector.js");
  reactHotLoader.register(Selector, "Selector", "/home/vsts/work/1/s/src/components/Selector.js");
  reactHotLoader.register(_default, "default", "/home/vsts/work/1/s/src/components/Selector.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(InnerSelect, "InnerSelect", "/home/vsts/work/1/s/src/components/Selector.js");
  reactHotLoader.register(Wrapper, "Wrapper", "/home/vsts/work/1/s/src/components/Selector.js");
  reactHotLoader.register(SelectBox, "SelectBox", "/home/vsts/work/1/s/src/components/Selector.js");
  reactHotLoader.register(SelectedValue, "SelectedValue", "/home/vsts/work/1/s/src/components/Selector.js");
  reactHotLoader.register(Dropdown, "Dropdown", "/home/vsts/work/1/s/src/components/Selector.js");
  reactHotLoader.register(Option, "Option", "/home/vsts/work/1/s/src/components/Selector.js");
  reactHotLoader.register(Placeholder, "Placeholder", "/home/vsts/work/1/s/src/components/Selector.js");
  reactHotLoader.register(Selector, "Selector", "/home/vsts/work/1/s/src/components/Selector.js");
  reactHotLoader.register(_default2, "default", "/home/vsts/work/1/s/src/components/Selector.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();