"use strict";

exports.__esModule = true;
exports.default = void 0;
require("typeface-open-sans");
require("typeface-roboto-condensed");
var _lodash = require("lodash");
var _polished = require("polished");
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var baseTheme = {
  treeSettings: {
    // in px
    // How far from parent left edge to vertical branch under it
    branchIndent: 14,
    // How far from vertical branch to children's left edge
    branchLength: 15,
    // How far up from bottom edge of node should horizontal branch sit
    branchHeight: 20
  },
  colors: {
    application: {
      base: "#cccccc"
    },
    icon: "#999999",
    border: "#999999",
    borderLight: "#cccccc",
    borderDark: "#3333333",
    text: "#333333",
    textMedium: "#999999",
    textLight: "#cccccc",
    textWhite: "#efefef",
    bgLight: "#efefef",
    bgMedium: "#999999",
    // Not used
    bgDark: "#333333",
    error: "#ce4844",
    scopeTypes: {
      Global: "#fd6b35",
      Virtual: "#3b6482",
      Sale: "#7db84c",
      Dependant: "#999999"
    },
    toasts: {
      error: "#ce4844",
      warn: "#f5a623",
      confirm: "#22b980"
    }
  },
  icons: {
    indicators: {
      up: "chevron-up",
      down: "dropdown-chevron-down",
      right: "dropdown-chevron-right",
      more: "arrow-more"
    },
    scopeTypes: {
      Global: "global-scope",
      Virtual: "virtual-scope",
      Sale: "sales-scope",
      Dependant: "dependent-scope"
    },
    // toast: {
    // 	confirm: "checkmark-circle",
    // 	warn: "warning",
    // 	error: "cross-circle",
    // },
    prev: "arrow-small-left",
    next: "arrow-small-right",
    menu: "app-list",
    sidebarOpen: "collapse",
    sidebarClosed: "expand",
    close: "close",
    date: "calendar-generic",
    time: "clock",
    backArrow: "arrow-large-left",
    loading: "sync",
    error: "warning",
    reportProblem: "report-problem-triangle"
  },
  fonts: {
    base: "Open Sans, sans-serif",
    header: "Roboto Condensed, sans-serif"
  }
};
var setApplicationColors = function setApplicationColors(theme) {
  if (!theme.colors.application.primary) {
    theme.colors.application.primary = theme.colors.application.base;
  }
  if (!theme.colors.application.highlight) {
    theme.colors.application.highlight = (0, _polished.tint)(0.86, theme.colors.application.base);
  }
  if (!theme.colors.application.select) {
    theme.colors.application.select = (0, _polished.tint)(0.7, theme.colors.application.base);
  }
  if (!theme.colors.application.dark) {
    theme.colors.application.dark = (0, _polished.shade)(0.2, theme.colors.application.base);
  }
  return theme;
};
var appHighlightColor_IS_DEPRECATED = {
  appHighlightColor: "#ff00ff"
};
var getTheme = function getTheme(overrides) {
  if (overrides === void 0) {
    overrides = {};
  }
  return setApplicationColors((0, _lodash.merge)({}, baseTheme, overrides, appHighlightColor_IS_DEPRECATED));
};
var _default = getTheme;
var _default2 = _default;
var _default3 = exports.default = _default2;
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(baseTheme, "baseTheme", "/home/vsts/work/1/s/src/getTheme.js");
  reactHotLoader.register(setApplicationColors, "setApplicationColors", "/home/vsts/work/1/s/src/getTheme.js");
  reactHotLoader.register(appHighlightColor_IS_DEPRECATED, "appHighlightColor_IS_DEPRECATED", "/home/vsts/work/1/s/src/getTheme.js");
  reactHotLoader.register(getTheme, "getTheme", "/home/vsts/work/1/s/src/getTheme.js");
  reactHotLoader.register(_default, "default", "/home/vsts/work/1/s/src/getTheme.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(baseTheme, "baseTheme", "/home/vsts/work/1/s/src/getTheme.js");
  reactHotLoader.register(setApplicationColors, "setApplicationColors", "/home/vsts/work/1/s/src/getTheme.js");
  reactHotLoader.register(appHighlightColor_IS_DEPRECATED, "appHighlightColor_IS_DEPRECATED", "/home/vsts/work/1/s/src/getTheme.js");
  reactHotLoader.register(getTheme, "getTheme", "/home/vsts/work/1/s/src/getTheme.js");
  reactHotLoader.register(_default2, "default", "/home/vsts/work/1/s/src/getTheme.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();