"use strict";

exports.__esModule = true;
exports.useFullEntityEditState = exports.default = void 0;
var _immutable = _interopRequireDefault(require("immutable"));
var _useDispatchWithModulesData = require("./../hooks/useDispatchWithModulesData");
var _view = require("./../actions/view");
var _modelValidationHelper = require("../utils/modelValidationHelper");
var _lodash = require("lodash");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default.signature : function (a) {
  return a;
};
// if you need to override default validation rules just pass new rules with default keys
// as properties of extendedValidationRules
var useFullEntityEditState = exports.useFullEntityEditState = function useFullEntityEditState(entityId, getFullEntityModelProperties, extendedValidationRules, dependencies) {
  if (extendedValidationRules === void 0) {
    extendedValidationRules = {};
  }
  if (dependencies === void 0) {
    dependencies = {};
  }
  var dispatchWithModulesData = (0, _useDispatchWithModulesData.useDispatchWithModulesData)();
  var mergedValidationRules = _objectSpread(_objectSpread({}, _modelValidationHelper.validationRules), extendedValidationRules);
  var isEditStateValid = function isEditStateValid(newValue, errorTypes, dependencies) {
    var error = null;
    errorTypes.forEach(function (errorType) {
      var isValid = mergedValidationRules[errorType] ? mergedValidationRules[errorType](newValue, dependencies) : true;
      if (isValid === false && error == null) {
        error = errorType;
      }
    });
    return error;
  };
  var buildFullEntityEditState = function buildFullEntityEditState(initializationContext) {
    var fullEntityEditModel = _immutable.default.fromJS({});
    var fullEntityModelProperties = getFullEntityModelProperties(initializationContext != null ? initializationContext : {});
    Object.entries(fullEntityModelProperties).forEach(function (_ref) {
      var _ref2 = _slicedToArray(_ref, 2),
        sectionName = _ref2[0],
        editStateFieldDefinitions = _ref2[1];
      Object.entries(editStateFieldDefinitions).forEach(function (_ref3) {
        var _fieldDefinition$erro;
        var _ref4 = _slicedToArray(_ref3, 2),
          fieldName = _ref4[0],
          fieldDefinition = _ref4[1];
        var allDependencies = _objectSpread(_objectSpread({}, dependencies), fieldDefinition.dependencies);
        var error = isEditStateValid(fieldDefinition.newValue, (_fieldDefinition$erro = fieldDefinition.errorTypes) != null ? _fieldDefinition$erro : [], allDependencies);
        var value = {
          value: fieldDefinition.newValue,
          wasModified: !(0, _lodash.isEqual)(fieldDefinition.initialValue, fieldDefinition.newValue)
        };
        if (error) {
          value.error = error;
        }
        var path = [entityId, sectionName, "model"].concat(fieldDefinition.keys);
        fullEntityEditModel = fullEntityEditModel.setIn(path, _immutable.default.fromJS(value));
      });
    });
    dispatchWithModulesData(_view.setFullEntityEditModel, [fullEntityEditModel]);
  };
  return buildFullEntityEditState;
};
__signature__(useFullEntityEditState, "useDispatchWithModulesData{dispatchWithModulesData}", function () {
  return [_useDispatchWithModulesData.useDispatchWithModulesData];
});
__signature__(useFullEntityEditState, "useDispatchWithModulesData{dispatchWithModulesData}", function () {
  return [_useDispatchWithModulesData.useDispatchWithModulesData];
});
var _default = useFullEntityEditState;
var _default2 = _default;
var _default3 = exports.default = _default2;
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(useFullEntityEditState, "useFullEntityEditState", "/home/vsts/work/1/s/src/hooks/useFullEntityEditState.js");
  reactHotLoader.register(_default, "default", "/home/vsts/work/1/s/src/hooks/useFullEntityEditState.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();
;
(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;
  if (!reactHotLoader) {
    return;
  }
  reactHotLoader.register(useFullEntityEditState, "useFullEntityEditState", "/home/vsts/work/1/s/src/hooks/useFullEntityEditState.js");
  reactHotLoader.register(_default2, "default", "/home/vsts/work/1/s/src/hooks/useFullEntityEditState.js");
})();
;
(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();